/*ProfiPacket - packet radio terminal program
  Copyright (C) 1999  Alexander Feigl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Author:

  Alexander Feigl
  Burachstrae 51

  D-88250 Weingarten

  Mail : Alexander.Feigl@gmx.de
*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "TNCThread.h"
#include <stdio.h>

TNCThread::TNCThread(void)
 {
  inpacket_type=-1;
  inpacket_size=-1;
  inpacket_received=0;   
  interface_open=0;
  interface_set=0;
  tnc_up=0;
 }
 
TNCThread::~TNCThread(void)
 {
 
 }


void TNCThread::receivedPacket(int type,int size,void *buffer)
 {
  fprintf(stderr,"Thread received : %d[%d]\n",type,size);
  switch (type)
   {
    case PACKET_SETINTERFACE:
     {
      if (size!=sizeof(packet_configure)) break;
      //FIXME : close interface if open
      memcpy(&IFaceConfig,buffer,sizeof(IFaceConfig));
      return;
     } 
    case PACKET_TNCUP:
     {
      if (tnc_up)
       {
        putPacket(PACKET_TNC_ISUP,0,0);
        return;
       }
      if (!openInterface(IFaceConfig.devicename,IFaceConfig.unit,
                        IFaceConfig.flags,IFaceConfig.baudrate))
       {
        putPacket(PACKET_TNC_NODEVICE,0,0);
        return;
       }
      fprintf(stderr,"Waking up TNC\n");
      return;
     }    
   }
 }