/*ProfiPacket - packet radio terminal program
  Copyright (C) 1999  Alexander Feigl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Author:

  Alexander Feigl
  Burachstrae 51

  D-88250 Weingarten

  Mail : Alexander.Feigl@gmx.de
*/


#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "QSO.h"
#include "global.h"
#include "Preferences.h"

#ifdef AmigaOS

#include <dos/dos.h>
#include <libraries/mui.h>
#include <exec/ports.h>
#include <devices/timer.h>

#else

#include "amigaemu.h"

#endif


struct DateStamp    CurrentDateStamp;      //Aktueller Zeitstempel des Systems
struct DateStamp    LastSysopActivity;     //Datestamp der letzten Sysop-Aktivit.
struct QSO         *QSOs;                  //Zeiger auf die QSO-Strukturen
struct Spy         *Spys;                  //Zeiger auf die SpyQSO-Strukturen
unsigned long       MaxChannel;            //Anzahl der Kanle
unsigned long       MaxSpy;                //Anzahl der QSO-Spione
  signed long       ActiveChannel;         //Aktiver Kanal (Anzeige,Abfrage)
struct PPPreferences Preferences;           //Preferences-Struktur 
unsigned long       RestartProgram;        //Flag ob Programm-Restart
unsigned long       CMessageNr;            //Nummer der aktuellen C-Message
unsigned long       StandardLanguage;      //Standardsprache

// things for editor.mcc

struct timerequest *TimerRequest;         //
struct MsgPort     *TimerPort;             //
Object             *PrefDataspace;         //
struct MUI_CustomClass *EditorClass;           //
struct MUI_CustomClass *EditorPrefClass;       //

unsigned char      Temporary[1024];

// things for GUI

struct GlobalHooks*HooksP;
struct GlobalArraysSTR *GlobalArraysP;
void              *MUIMasterBase;
unsigned long      MUISignal;
Object            *Application;
Object            *MainWindow;
Object            *PrefWindow;
Object            *LaunchWindow;
Object            *SaveBufferWindow;
Object            *ConnectWindow;
Object            *UserSettingsWindow;
Object            *ConnectMsgWindow;
Object            *BBSMainWindow;
Object            *BBSSendWindow;
Object            *BBSViewWindow;
Object            *SpyWindow;
Object            *MHeardWindow;
Object            *MHeardLWindow;
Object            *GetUserDataWindow;
Object            *EncryptionWindow;
void              *Locale;
void              *Catalog;
void              *Topaz8;
void              *PcFont8;
void              *MenuBuild;
signed long       MonitorSaveChannel;   //Rettungsspeicher fr ActiveChannel
unsigned char     WindowTitle[80];      //Speicher fr den Screentitle
unsigned long     OldTimeMins;          //Alte Minuten des Timestamp fr Refresh
unsigned long     NumLock;              //Zustand des NumLock fr Tastatur
  signed long     AltASCII;             //ASCII-Zahl des Alt-ASCII-Servers
unsigned long     InsertMode;           //Zustand des InsertMode fr Edit
struct PPPreferences NewPref;           //Neue Preferences (bei Edit)
Object           *MessageWindow;        //Zeiger auf Messagewindow
Object           *MessageGroup;         //Zeiger auf Messagewindow-gruppe
unsigned long     MessageWindowTime;    //Timeout fr Messagewindow
unsigned long     MessageWindowSecs;    //Alte Sekunden fr Messagewindow
char            **StringSpeedup;        //Zeiger auf String-Speedup-Tabelle
unsigned long     StringSpeedupSize;    //Gre des String-Speedup-Tabelle
unsigned char     TickerLine[80];       //Monitor-Ticker-Line
unsigned long     HardwareInfo[8];      //Information ber Hardwarestatus
unsigned long     HardwareInfoData[8];  //Zusatzdaten s.o. (z.B. Resyncnummer)
unsigned long     GUIPollCounter;       //Zhler fr GUI-Poll-Aufruf
unsigned long     PacketPollCounter;    //Zhler fr Packet-Poll-Aufruf
unsigned long     QSOPollCounter;       //Zhler fr QSO-Poll-Aufruf
unsigned long     MailPollCounter;      //Zhler fr Mail-Poll-Aufruf

// things for packet

void             *HardUnits[8];
unsigned long    HardUnitErrors[8];
  signed long    MonitorHUnit;

// things for Audio

Object           *AudioObjects;
void             *AudioTasks[32];

// things for QSO

void             *QSOBase;
void             *DelayBuffers;          //Zeiger auf DelayBuffers
struct List       ServerList;            //Liste der verfgbaren Server
unsigned long     ServerPollCounter;     //Zhler fr Serverpoll
struct List       UserBaseList;          //Liste der benutzten User
struct User      *UserBaseStandard;      //Zeiger auf den Standarduser
unsigned char    *HuffmanSpeedup;        //Zeiger auf Huffman-Speedup-Tabelle
struct MHeardEntry *MHeardBase;          //Zeiger auf MHeard-Base
struct MHeardEntry *MHeardPointer;       //Zeiger auf den letzten MHeard-Eintrag
unsigned char    *PrPaPointer;           //Zeiger auf PrPa-Memory
unsigned long     PrPaLength;            //Lnge der PrPa-Daten
unsigned long     PrPaType;              //Typ der PrPa-Daten
unsigned long     PrPaVersion;           //Version der PrPa-Daten
unsigned long     PrPaReceived;          //Zahl der empfangenen PrPa-Bytes
struct BBSObject *BBSHook;               //Anker fr BBS-Objekte
struct CatalogCache *CatalogHook;        //Anker fr die Catalogs
struct LockCall  *LockCalls;             //Anker fr gesperrte Calls


/*


gl_OldCurrentDir        rs.l 1          ;Altes Current-Dir vor WBStartup
*/
