/*ProfiPacket - packet radio terminal program
  Copyright (C) 1999  Alexander Feigl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Author:

  Alexander Feigl
  Burachstrae 51

  D-88250 Weingarten

  Mail : Alexander.Feigl@gmx.de
*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __GNUC__
#define _storage_text_ __attribute__ ((section(".text")))
#else
#define _storage_text_
#endif


#define MAKE_ANSIDEFAULT

#define Class_Name "Editor.mcp"
#define Class_IDString "$VER: Editor.mcp 16.3 (05.08.97) 1997 Alexander Feigl\015\012"
#define Class_Version 16
#define Class_Revision 3

#define ClassP_SuperClass "Group.mui"
#include <libraries/mui.h>

#include "EditorPrefs.h"
#include "Editor.h"
#include "EditorCommon.h"

#include <graphics/scale.h>
#include <exec/memory.h>


#include <clib/muimaster_protos.h>
#include <clib/alib_protos.h>
#include <clib/utility_protos.h>
#include <clib/graphics_protos.h>
#include <clib/exec_protos.h>
#include <clib/intuition_protos.h>
#include <clib/keymap_protos.h>

#ifdef __GNUC__


extern void *SysBase;
extern void *IntuitionBase;
extern void *UtilityBase;
extern void *GfxBase;
extern void *KeymapBase;
extern void *MUIMasterBase;

#define NO_INLINE_STDARG
#include <inline/muimaster.h>
#include <inline/exec.h>
#include <inline/intuition.h>
#include <inline/utility.h>
#include <inline/graphics.h>
#include <inline/keymap.h>
#undef MUI_CreateCustomClass
#endif

#include <devices/inputevent.h>

#include <exec/memory.h>



typedef const unsigned char *cstring;

static const cstring _storage_text_ PageNames[] = {
                        (cstring) "ANSI Pens",
                        (cstring) "Cursor",
                        (cstring) "Misc",
                        (cstring) NULL};

static const cstring _storage_text_ CTypeNames[] = {
                        (cstring) "block cursor",
                        (cstring) "h-line cursor",
                        (cstring) "v-line cursor",
                        (cstring) NULL};

static const cstring _storage_text_ CBlinkNames[] = {
                        (cstring) "static",
                        (cstring) "blinking",
                        (cstring) NULL};

static const cstring _storage_text_ SBackNames[] = {
                        (cstring) "No",
                        (cstring) "Yes",
                        (cstring) NULL};

static ULONG _New(struct IClass *cl, Object *obj,struct opSet *msg);
static ULONG _Dispose(struct IClass *cl, Object *obj, Msg msg);
static ULONG _Setup(struct IClass *cl,Object *obj, struct MUIP_Setup *msg);
static ULONG _Cleanup(struct IClass *cl,Object *obj,Msg msg);
static ULONG _ConfigToGadgets(struct IClass *cl, Object *obj, struct MUIP_Settingsgroup_ConfigToGadgets *msg);
static ULONG _GadgetsToConfig(struct IClass *cl, Object *obj, struct MUIP_Settingsgroup_GadgetsToConfig *msg);



extern void *Dispatcher_Entry();
ULONG ClassPDispatcher(struct IClass *cl,Object *obj,Msg msg);

int MCCPEditor_Init(void)
{
 EditorPrefClass=MUI_CreateCustomClass(NULL,ClassP_SuperClass,NULL,
                                   sizeof(struct ClassP_Data),Dispatcher_Entry);
 if (EditorPrefClass==NULL) return(FALSE);
 EditorPrefClass->mcc_Class->cl_UserData=(ULONG) ClassPDispatcher;
 return(TRUE);
}





static ULONG _New(struct IClass *cl, Object *obj,struct opSet *msg)
{
        struct ClassP_Data *data;

        if (!(obj = (Object *)DoSuperMethodA(cl, obj, (APTR ) msg)))
                return(0);

        /*** init data ***/
        data = INST_DATA(cl, obj);


        /*** make group ***/
        data->PrefsGroup = RegisterGroup(PageNames),
                             MUIA_CycleChain,TRUE,
                             MUIA_Register_Frame,TRUE,
                             Child,ColGroup(4),
                                Child, FreeKeyLabel("ANSI Color 0", '0'),
                                Child, data->ANSIPens[0]= MUI_NewObject(MUIC_Poppen,
                                        MUIA_Window_Title, "Adjust Pen ANSI Color 0",
                                        MUIA_CycleChain,TRUE,
                                        MUIA_ControlChar, '0',
                                        MUIA_Draggable, TRUE,
                                        MUIA_ShortHelp, "Color for ANSI Color 0 of editor.",
                                        End,
                                Child, FreeKeyLabel("ANSI Color 1", '1'),
                                Child, data->ANSIPens[1]= MUI_NewObject(MUIC_Poppen,
                                        MUIA_Window_Title, "Adjust Pen ANSI Color 1",
                                        MUIA_CycleChain,TRUE,
                                        MUIA_ControlChar, '1',
                                        MUIA_Draggable, TRUE,
                                        MUIA_ShortHelp, "Color for ANSI Color 1 of editor.",
                                        End,
                                Child, FreeKeyLabel("ANSI Color 2", '2'),
                                Child, data->ANSIPens[2]= MUI_NewObject(MUIC_Poppen,
                                        MUIA_Window_Title, "Adjust Pen ANSI Color 2",
                                        MUIA_CycleChain,TRUE,
                                        MUIA_ControlChar, '2',
                                        MUIA_Draggable, TRUE,
                                        MUIA_ShortHelp, "Color for ANSI Color 2 of editor.",
                                        End,
                                Child, FreeKeyLabel("ANSI Color 3", '3'),
                                Child, data->ANSIPens[3]= MUI_NewObject(MUIC_Poppen,
                                        MUIA_Window_Title, "Adjust Pen ANSI Color 3",
                                        MUIA_CycleChain,TRUE,
                                        MUIA_ControlChar, '3',
                                        MUIA_Draggable, TRUE,
                                        MUIA_ShortHelp, "Color for ANSI Color 3 of editor.",
                                        End,
                                Child, FreeKeyLabel("ANSI Color 4", '4'),
                                Child, data->ANSIPens[4]= MUI_NewObject(MUIC_Poppen,
                                        MUIA_Window_Title, "Adjust Pen ANSI Color 4",
                                        MUIA_CycleChain,TRUE,
                                        MUIA_ControlChar, '4',
                                        MUIA_Draggable, TRUE,
                                        MUIA_ShortHelp, "Color for ANSI Color 4 of editor.",
                                        End,
                                Child, FreeKeyLabel("ANSI Color 5", '5'),
                                Child, data->ANSIPens[5]= MUI_NewObject(MUIC_Poppen,
                                        MUIA_Window_Title, "Adjust Pen ANSI Color 5",
                                        MUIA_CycleChain,TRUE,
                                        MUIA_ControlChar, '5',
                                        MUIA_Draggable, TRUE,
                                        MUIA_ShortHelp, "Color for ANSI Color 5 of editor.",
                                        End,
                                Child, FreeKeyLabel("ANSI Color 6", '6'),
                                Child, data->ANSIPens[6]= MUI_NewObject(MUIC_Poppen,
                                        MUIA_Window_Title, "Adjust Pen ANSI Color 6",
                                        MUIA_CycleChain,TRUE,
                                        MUIA_ControlChar, '6',
                                        MUIA_Draggable, TRUE,
                                        MUIA_ShortHelp, "Color for ANSI Color 6 of editor.",
                                        End,
                                Child, FreeKeyLabel("ANSI Color 7", '7'),
                                Child, data->ANSIPens[7]= MUI_NewObject(MUIC_Poppen,
                                        MUIA_Window_Title, "Adjust Pen ANSI Color 7",
                                        MUIA_CycleChain,TRUE,
                                        MUIA_ControlChar, '7',
                                        MUIA_Draggable, TRUE,
                                        MUIA_ShortHelp, "Color for ANSI Color 7 of editor.",
                                        End,
                                End,                    
                             Child,VGroup,
                                Child, ColGroup(4),
                                       Child,FreeKeyLabel("Color in editor",'e'),
                                          Child,data->ObjCursorEditorPen=MUI_NewObject(MUIC_Poppen,
                                            MUIA_Window_Title,"Color of cursor in editor",
                                            MUIA_CycleChain,TRUE,
                                            MUIA_ControlChar,'e',
                                            MUIA_Draggable,TRUE,
                                            MUIA_ShortHelp,"Cursor color of a editor",
                                            End,

                                       Child,FreeKeyLabel("Color in scroller",'s'),
                                          Child,data->ObjCursorScrollerPen=MUI_NewObject(MUIC_Poppen,
                                            MUIA_Window_Title,"Color of cursor in scroller",
                                            MUIA_CycleChain,TRUE,
                                            MUIA_ControlChar,'s',
                                            MUIA_Draggable,TRUE,
                                            MUIA_ShortHelp,"Cursor color of a scroller",
                                            End,
                                       Child,FreeKeyLabel("Blink type in editor",'b'),
                                          Child,data->ObjBlinkEditor=MUI_NewObject(MUIC_Cycle,
                                            MUIA_Cycle_Entries,CBlinkNames,
                                            MUIA_CycleChain,TRUE,
                                            MUIA_ControlChar,'b',
                                            MUIA_ShortHelp,"Blinking type in a editor",
                                            End,
                                       Child,FreeKeyLabel("Blink type in a scroller",'l'),
                                          Child,data->ObjBlinkScroller=MUI_NewObject(MUIC_Cycle,
                                            MUIA_Cycle_Entries,CBlinkNames,
                                            MUIA_CycleChain,TRUE,
                                            MUIA_ControlChar,'l',
                                            MUIA_ShortHelp,"Blinking type in a scroller",
                                            End,
                                       Child,FreeKeyLabel("Type in insert mode",'t'),
                                          Child,data->ObjCursorInsert=MUI_NewObject(MUIC_Cycle,
                                            MUIA_Cycle_Entries,CTypeNames,
                                            MUIA_CycleChain,TRUE,
                                            MUIA_ControlChar,'t',
                                            MUIA_ShortHelp,"Cursor type in insert mode",
                                            End,
                                       Child,FreeKeyLabel("Type in overwrite mode",'y'),
                                          Child,data->ObjCursorOverwrite=MUI_NewObject(MUIC_Cycle,
                                            MUIA_Cycle_Entries,CTypeNames,
                                            MUIA_CycleChain,TRUE,
                                            MUIA_ControlChar,'y',
                                            MUIA_ShortHelp,"Cursor type in overwrite mode",
                                            End,
                                       Child,FreeKeyLabel("Blink frequency",'f'),
                                       Child,data->ObjBlinkFrequency=MUI_NewObject(MUIC_Slider,
                                            MUIA_Slider_Min,5,
                                            MUIA_Slider_Max,100,
                                            MUIA_Slider_Reverse,TRUE,
                                            MUIA_ShortHelp,"Blink frequency in 1/50 s",
                                            MUIA_ControlChar,'f',
                                            MUIA_CycleChain,TRUE,
                                            End,
                                  End,
                                End,
                             Child,VGroup,
                                    Child,ColGroup(2),
                                       Child,FreeKeyLabel("Solid background",'g'),
                                       Child,data->ObjSolidBackground=MUI_NewObject(MUIC_Cycle,
                                            MUIA_Cycle_Entries,SBackNames,
                                            MUIA_CycleChain,TRUE,
                                            MUIA_ControlChar,'g',
                                            MUIA_ShortHelp,"Background is solid (much faster)",
                                            End,
                                    End,
                                End,
                End;

        if(data->PrefsGroup==NULL)
        {
                CoerceMethod(cl, obj, OM_DISPOSE);
                return(0);
        }

        DoMethod(obj, OM_ADDMEMBER, data->PrefsGroup);

 return ( (ULONG) (obj) );
}



static ULONG _Dispose(struct IClass *cl, Object *obj, Msg msg)
{
 /*struct ClassP_Data *data = INST_DATA(cl, obj);*/
 return(DoSuperMethodA(cl,obj,msg));
}


static ULONG _Setup(struct IClass *cl,Object *obj, struct MUIP_Setup *msg)
{
        /*struct ClassP_Data *data = INST_DATA(cl, obj);*/

        if(!(DoSuperMethodA(cl,obj,(Msg)msg)))
                return(FALSE);

        
        return(TRUE);
}


static ULONG _Cleanup(struct IClass *cl,Object *obj,Msg msg)
{
        /*struct ClassP_Data *data = INST_DATA(cl, obj);*/


        return(DoSuperMethodA(cl,obj,msg));
}



static ULONG _ConfigToGadgets(struct IClass *cl, Object *obj, struct MUIP_Settingsgroup_ConfigToGadgets *msg)
{
        struct ClassP_Data *data = INST_DATA(cl, obj);

        void *d;
        unsigned long i;

        /*** set colors ***/

        if (
            (d = (void *) (DoMethod(msg->configdata, 
                          MUIM_Dataspace_Find, MUICFG_Editor_ANSIPens)))
            !=NULL)
        {
         CopyMem(d,data->ANSISpecs,8*sizeof(struct MUI_PenSpec));
        }
        else
        {
         Init_ANSISpecs(data->ANSISpecs);
        }

        if (
            ( d= (void *) (DoMethod(msg->configdata,
                          MUIM_Dataspace_Find,MUICFG_Editor_CursEditorPen)))
            !=NULL)
        {
         CopyMem(d,&data->CursorEditorPen,sizeof(struct MUI_PenSpec));
        }
        else
        {
         Init_CursEditorPen(&data->CursorEditorPen);
        }

        if (
            ( d= (void *) (DoMethod(msg->configdata,
                          MUIM_Dataspace_Find,MUICFG_Editor_CursScrollPen)))
            !=NULL)
        {
         CopyMem(d,&data->CursorScrollerPen,sizeof(struct MUI_PenSpec));
        }
        else
        {
         Init_CursScrollPen(&data->CursorScrollerPen);
        }

        if (
            ( d= (void *) (DoMethod(msg->configdata,
                          MUIM_Dataspace_Find,MUICFG_Editor_BlinkEditor)))
            !=NULL)
        {
         CopyMem(d,&data->BlinkEditor,sizeof(data->BlinkEditor));
        }
        else
        {
         data->BlinkEditor=Standard_BlinkEditor;
        }

        if (
            ( d= (void *) (DoMethod(msg->configdata,
                          MUIM_Dataspace_Find,MUICFG_Editor_BlinkScroller)))
            !=NULL)
        {
         CopyMem(d,&data->BlinkScroller,sizeof(data->BlinkScroller));
        }
        else
        {
         data->BlinkScroller=Standard_BlinkScroller;
        }

        if (
            ( d= (void *) (DoMethod(msg->configdata,
                          MUIM_Dataspace_Find,MUICFG_Editor_CursorInsert)))
            !=NULL)
        {
         CopyMem(d,&data->CursorInsert,sizeof(data->CursorInsert));
        }
        else
        {
         data->CursorInsert=Standard_CursorInsert;
        }

        if (
            ( d= (void *) (DoMethod(msg->configdata,
                          MUIM_Dataspace_Find,MUICFG_Editor_CursorOverwr)))
            !=NULL)
        {
         CopyMem(d,&data->CursorOverwrite,sizeof(data->CursorOverwrite));
        }
        else
        {
         data->CursorOverwrite=Standard_CursorOverwrite;
        }

        if (
            ( d= (void *) (DoMethod(msg->configdata,
                          MUIM_Dataspace_Find,MUICFG_Editor_BlinkFrequency)))
            !=NULL)
        {
         CopyMem(d,&data->BlinkFrequency,sizeof(data->BlinkFrequency));
        }
        else
        {
         data->BlinkFrequency=Standard_BlinkFrequency;
        }

        if (
            ( d= (void *) (DoMethod(msg->configdata,
                          MUIM_Dataspace_Find,MUICFG_Editor_SolidBackground)))
            !=NULL)
        {
         CopyMem(d,&data->SolidBackground,sizeof(data->SolidBackground));
        }
        else
        {
         data->SolidBackground=Standard_SolidBackground;
        }



        
        for (i=0;i<8;++i)
         {
          set (data->ANSIPens[i], MUIA_Pendisplay_Spec, 
              (ULONG) &data->ANSISpecs[i]);
         }
        set(data->ObjCursorEditorPen,MUIA_Pendisplay_Spec,
              (ULONG) &data->CursorEditorPen);
        set(data->ObjCursorScrollerPen,MUIA_Pendisplay_Spec,
              (ULONG) &data->CursorScrollerPen);

        set(data->ObjBlinkEditor,MUIA_Cycle_Active,data->BlinkEditor);
        set(data->ObjBlinkScroller,MUIA_Cycle_Active,data->BlinkScroller);
        set(data->ObjCursorInsert,MUIA_Cycle_Active,data->CursorInsert);
        set(data->ObjCursorOverwrite,MUIA_Cycle_Active,data->CursorOverwrite);
        set(data->ObjBlinkFrequency,MUIA_Slider_Level,data->BlinkFrequency);
        set(data->ObjSolidBackground,MUIA_Cycle_Active,data->SolidBackground);
        return(0);
}



static ULONG _GadgetsToConfig(struct IClass *cl, Object *obj, struct MUIP_Settingsgroup_GadgetsToConfig *msg)
{
        struct ClassP_Data *data = INST_DATA(cl, obj);

        unsigned long i;
        void *d;

        for (i=0;i<8;++i)
         {
          get(data->ANSIPens[i],MUIA_Pendisplay_Spec, &d);
          if (d==NULL) return (0);
          CopyMem(d,&data->ANSISpecs[i],sizeof(struct MUI_PenSpec));
         }
        get(data->ObjCursorEditorPen,MUIA_Pendisplay_Spec,&d);
        if (d==NULL) return(0);
        CopyMem(d,&data->CursorEditorPen,sizeof(struct MUI_PenSpec));
        get(data->ObjCursorScrollerPen,MUIA_Pendisplay_Spec,&d);
        if (d==NULL) return(0);
        CopyMem(d,&data->CursorScrollerPen,sizeof(struct MUI_PenSpec));
        get(data->ObjBlinkEditor,MUIA_Cycle_Active,&data->BlinkEditor);
        get(data->ObjBlinkScroller,MUIA_Cycle_Active,&data->BlinkScroller);
        get(data->ObjCursorInsert,MUIA_Cycle_Active,&data->CursorInsert);
        get(data->ObjCursorOverwrite,MUIA_Cycle_Active,&data->CursorOverwrite);
        get(data->ObjBlinkFrequency,MUIA_Slider_Level,&data->BlinkFrequency);
        get(data->ObjSolidBackground,MUIA_Cycle_Active,&data->SolidBackground);

        DoMethod(msg->configdata, MUIM_Dataspace_Add, data->ANSISpecs,
                      8*sizeof(struct MUI_PenSpec), MUICFG_Editor_ANSIPens);
        DoMethod(msg->configdata, MUIM_Dataspace_Add, &data->CursorEditorPen,
                      sizeof(struct MUI_PenSpec),MUICFG_Editor_CursEditorPen);
        DoMethod(msg->configdata, MUIM_Dataspace_Add, &data->CursorScrollerPen,
                      sizeof(struct MUI_PenSpec),MUICFG_Editor_CursScrollPen);
        DoMethod(msg->configdata, MUIM_Dataspace_Add, &data->BlinkEditor,
                      sizeof(data->BlinkEditor),MUICFG_Editor_BlinkEditor);
        DoMethod(msg->configdata, MUIM_Dataspace_Add, &data->BlinkScroller,
                      sizeof(data->BlinkScroller),MUICFG_Editor_BlinkScroller);
        DoMethod(msg->configdata, MUIM_Dataspace_Add, &data->CursorInsert,
                      sizeof(data->CursorInsert),MUICFG_Editor_CursorInsert);
        DoMethod(msg->configdata, MUIM_Dataspace_Add, &data->CursorOverwrite,
                      sizeof(data->CursorOverwrite),MUICFG_Editor_CursorOverwr);
        DoMethod(msg->configdata, MUIM_Dataspace_Add, &data->BlinkFrequency,
                      sizeof(data->BlinkFrequency),MUICFG_Editor_BlinkFrequency);
        DoMethod(msg->configdata, MUIM_Dataspace_Add, &data->SolidBackground,
                      sizeof(data->SolidBackground),MUICFG_Editor_SolidBackground);


        return(0);
}





ULONG ClassPDispatcher(struct IClass *cl,Object *obj,Msg msg)
{
        switch(msg->MethodID)
        {
                case OM_NEW        : return(_New      (cl,obj,(struct opSet *)msg));
                case OM_DISPOSE    : return(_Dispose  (cl,obj,(APTR)msg));
                case MUIM_Setup    : return(_Setup    (cl,obj,(APTR)msg));
                case MUIM_Cleanup  : return(_Cleanup  (cl,obj,(APTR)msg));

                case MUIM_Settingsgroup_ConfigToGadgets: return(_ConfigToGadgets(cl,obj,(APTR)msg));
                case MUIM_Settingsgroup_GadgetsToConfig: return(_GadgetsToConfig(cl,obj,(APTR)msg));

        }

        return(DoSuperMethodA(cl,obj,msg));
}


