/*ProfiPacket - packet radio terminal program
  Copyright (C) 1999  Alexander Feigl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
~
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Author:

  Alexander Feigl
  Burachstrae 51

  D-88250 Weingarten

  Mail : Alexander.Feigl@gmx.de
*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif


#ifndef DISABLE_BBS


#include "GUIProtos.h"
#include "global.h"
#include "Mail.h"



#include <libraries/mui.h>

#include <libraries/asl.h>

#include <devices/timer.h>

#include <exec/lists.h>
#include <exec/memory.h>
#include <dos/exall.h>

#include <clib/muimaster_protos.h>
#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/alib_protos.h>
#include <clib/intuition_protos.h>
#include <clib/utility_protos.h>

#ifdef __GNUC__


extern void *DOSBase;
extern void *SysBase;
extern void *IntuitionBase;
extern void *UtilityBase;
extern void *MUIMasterBase;

#define NO_INLINE_STDARG
#include <inline/muimaster.h>
#include <inline/dos.h>
#include <inline/exec.h>
#include <inline/intuition.h>
#include <inline/utility.h>

#endif

#ifndef MAKE_ID
#define MAKE_ID(a,b,c,d) ((ULONG) (a)<<24 | (ULONG) (b)<<16 | (ULONG) (c)<<8 | (ULONG) (d))
#endif

void FillHook(struct Hook *MyHook,void (*Function)(),void *FunctionData);


void GUIMAIL_MainHook(struct Hook *MyHook,unsigned long *Param,void *Object,
                         void *Data);

void GUIMAIL_SendHook(struct Hook *MyHook,unsigned long *Param,void *Object,
                          void *Data);

unsigned long GUIMAIL_SendStream(struct Hook *MyHook,unsigned long *Param,void *Object,
                          void *Data);


void GUIMAIL_RefreshList(void);
signed long GUIMAIL_GetSelected(void);
int GUIMAIL_SendMail(unsigned char *ToPreset,unsigned char *AtPreset,
                     unsigned char *TitlePreset,unsigned long mode);


void GUIMAIL_SendHook(struct Hook *MyHook,unsigned long *Param,void *Object,
                          void *Data);



int GUIMAIL_ViewMail(unsigned long number, unsigned long mode);
void GUIMAIL_ViewHook(struct Hook *MyHook,unsigned long *Param,void *Object,
                          void *Data);
unsigned long GUIMAIL_ReceiveStream(struct Hook *MyHook,unsigned long *Param,void *Object,
                          void *Data);




#define mmobject(xx) GlobalArraysP->BBSMainObjects[xx]
#define msobject(xx) GlobalArraysP->BBSSendObjects[xx]
#define mvobject(xx) GlobalArraysP->BBSViewObjects[xx]


void GUIMAIL_Mailbox(void)
{

 if (BBSMainWindow==NULL)
   {

     GlobalArraysP->BBSMainArray1[0]=GUI_String(347);
     GlobalArraysP->BBSMainArray1[1]=GUI_String(348);
     GlobalArraysP->BBSMainArray1[2]=GUI_String(349);
     GlobalArraysP->BBSMainArray1[3]=GUI_String(350);
     GlobalArraysP->BBSMainArray1[4]=NULL;

     FillHook(&HooksP->BBSMainHook,(void *) GUIMAIL_MainHook,NULL);


     BBSMainWindow =
                 WindowObject,
                     MUIA_Window_Title, GUI_String(339),
                     MUIA_Window_ID   , MAKE_ID('B','B','S','M'),

                     WindowContents,

                       VGroup,
                           Child,mmobject(0)=MUI_NewObject(MUIC_Listview,
                                  MUIA_Background,MUII_ListBack,
                                  MUIA_Frame,MUIV_Frame_InputList,
                                  MUIA_Font,MUIV_Font_Fixed,
                                  MUIA_Listview_List,
                                     MUI_NewObject(MUIC_List,
                                             MUIA_List_ConstructHook,MUIV_List_ConstructHook_String,
                                             MUIA_List_DestructHook,MUIV_List_DestructHook_String,
                                     End,
                                  End,

                           Child,ColGroup(2),
                                 Child,Label(GUI_String(476)),
                                 Child,mmobject(1)=Cycle(GlobalArraysP->BBSMainArray1),
                             End,
                           Child,ColGroup(3),
                                 Child,mmobject(2)=SimpleButton(GUI_String(351)),
                                 Child,mmobject(3)=SimpleButton(GUI_String(352)),
                                 Child,mmobject(4)=SimpleButton(GUI_String(353)),
                                 Child,mmobject(5)=SimpleButton(GUI_String(354)),
                                 Child,mmobject(6)=SimpleButton(GUI_String(355)),
                                 Child,mmobject(7)=SimpleButton(GUI_String(356)),


                             End,
                         End,
                     End;

    if (BBSMainWindow==NULL)
        {
            GUI_LowMemory();
            return;
        }

    DoMethod(Application,OM_ADDMEMBER,BBSMainWindow);

    {
     unsigned long i;
     for (i=0;i<8;++i)
      {
       set(mmobject(i),MUIA_CycleChain,1);
      }

    }


    DoMethod(BBSMainWindow,MUIM_Notify,MUIA_Window_CloseRequest,TRUE,
             BBSMainWindow,3,MUIM_CallHook,&HooksP->BBSMainHook,0);

    DoMethod(mmobject(1),MUIM_Notify,MUIA_Cycle_Active,MUIV_EveryTime,
             mmobject(1),3,MUIM_CallHook,&HooksP->BBSMainHook,1);
    DoMethod(mmobject(0),MUIM_Notify,MUIA_List_Active,MUIV_EveryTime,
             mmobject(0),3,MUIM_CallHook,&HooksP->BBSMainHook,2);

     {
      int i;
      for (i=2;i<8;++i)
       {
        DoMethod(mmobject(i),MUIM_Notify,MUIA_Pressed,FALSE,
                 mmobject(i),3,MUIM_CallHook,&HooksP->BBSMainHook,i+1);
       }
     }
   }


  {
   unsigned long status;

   get(BBSMainWindow,MUIA_Window_Open,&status);
   if (status==TRUE) return;
  }



 GUIMAIL_RefreshList();
 set(BBSMainWindow,MUIA_Window_Open,TRUE);

 return;
}

signed long GUIMAIL_GetSelected(void)
{
 unsigned long current;
 unsigned char *cstr;
 unsigned long cnum;
 get(mmobject(0),MUIA_List_Active,&current);
 if (current==MUIV_List_Active_Off) return(-1);
 if (current<2) return(-1);
 DoMethod(mmobject(0),MUIM_List_GetEntry,current,&cstr);
 if (cstr==NULL) return(-1);
 cnum=0;

 while ( *cstr==' ') cstr++;

 while ( (*cstr!=' ') && (*cstr!='\0') )
  {
   if ( (*cstr>'9') || (*cstr<'0')) return(-1);
   cnum*=10;
   cnum+= ((*cstr)-'0');
   cstr++;
  }
 return(cnum);
}


void GUIMAIL_RefreshList(void)
{
 unsigned long rmode;
 unsigned char linebuf[196];
 signed long xmail;

 get(mmobject(1),MUIA_Cycle_Active,&rmode);

 switch (rmode)
  {
   case 0:
    rmode=1;
    break;
   case 1:
    rmode=2;
    break;
   case 2:
    rmode=5;
    break;
   case 3:
    rmode=6;
    break;
  }

 set(mmobject(0),MUIA_List_Quiet,TRUE);
 DoMethod(mmobject(0),MUIM_List_Clear);

 xmail=0;
 while (1) {

   xmail=MAIL_GetMailLines(rmode,xmail,NULL,linebuf);
   if (xmail==0) break;
    {
     char *sptr;
     sptr=linebuf;
     while (*sptr!='\0')
      {
       if (*(sptr)==0x0d) *(sptr)=' ';
       ++sptr;
      }
    }


   MAIN_ConvertToAmiga(linebuf);

   DoMethod(mmobject(0),MUIM_List_InsertSingle,
              linebuf,MUIV_List_Insert_Bottom);

  }

 set(mmobject(0),MUIA_List_Quiet,FALSE);
}

void GUIMAIL_MainHook(struct Hook *MyHook,unsigned long *Param,void *Object,
                         void *Data)
{

 switch (*Param)
  {
   case 0:
    set (BBSMainWindow,MUIA_Window_Open,FALSE);
    break;
   case 1:
    GUIMAIL_RefreshList();
    break;
   case 2:
    if (GUIMAIL_GetSelected()==-1)
     {
      nnset (mmobject(0),MUIA_List_Active,MUIV_List_Active_Off);
     }
    break;
   case 3:  /* send*/
    GUIMAIL_SendMail(NULL,NULL,NULL,0);
    break;
   case 4:  /* copy*/
     {
      unsigned char retitle[80];
      signed long mnum;

      mnum=GUIMAIL_GetSelected();
      if (mnum==-1) break;

       {
        const unsigned char *sptr;
        unsigned char *dptr;
        unsigned long i;
        void *mymail;
        mymail=MAIL_OpenMail(mnum,NULL);
        if (mymail==NULL) break;
        if (mymail== ((void *)-1 )) break;
        sptr=MAIL_GetMailFm(mymail);
        dptr=retitle;
        *(dptr++)='C';
        *(dptr++)='P';
        *(dptr++)=' ';
        i=4;
        while ((*(sptr)!='\0') ) { ++i;*(dptr++)=*(sptr++);};
        *(dptr++)=':';
        sptr=MAIL_GetMailTitle(mymail);
        while ((*(sptr)!='\0') && (i<80)) { ++i;*(dptr++)=*(sptr++);};
        *(dptr)='\0';
        MAIL_CloseMail(mymail);
       }
      GUIMAIL_SendMail(NULL,NULL,retitle,2+mnum);
      break;
     }
   case 5:  /* kill*/
     {
      signed long mnum,err;
      mnum=GUIMAIL_GetSelected();
      if (mnum==-1) break;
      err=MAIL_KillMail(mnum,NULL);
      if (err==0)
       {
        GUIMAIL_RefreshList();
        break;
       }
      switch (err)
       {
        case -1:
          err=358;
          break;
        case -2:
          err=359;
          break;
        case -3:
          err=360;
          break;
       }
      GUI_DisplayEventWindow(GUI_String(err));
      break;
     }

   case 6:  /* show*/
     {
      signed long mnum;
      if ( (mnum=GUIMAIL_GetSelected())==-1) break;
      GUIMAIL_ViewMail(mnum,0);
      break;
     }
   case 7:  /* extract*/
     {
      signed long mnum;
      if ( (mnum=GUIMAIL_GetSelected())==-1) break;
      GUIMAIL_ViewMail(mnum,1);
      break;
     }
    break;
   case 8:  /* reply*/
     {
      unsigned char retitle[80];
      unsigned char recall[12];
      signed long mnum;

      mnum=GUIMAIL_GetSelected();
      if (mnum==-1) break;

       {
        const unsigned char *sptr;
        unsigned char *dptr;
        unsigned long i;
        void *mymail;
        mymail=MAIL_OpenMail(mnum,NULL);
        if (mymail==NULL) break;
        if (mymail== ((void *)-1 )) break;
        sptr=MAIL_GetMailFm(mymail);
        dptr=recall;
        do { *(dptr++)=*(sptr++);} while ( *(sptr-1)!='\0');
        sptr=MAIL_GetMailTitle(mymail);
        dptr=retitle;
        *(dptr++)='R';
        *(dptr++)='e';
        *(dptr++)=':';
        i=3;
        while ((*(sptr)!='\0') && (i<80)) { ++i;*(dptr++)=*(sptr++);};
        *(dptr)='\0';
        MAIL_CloseMail(mymail);
       }
      GUIMAIL_SendMail(recall,NULL,retitle,1);
      break;
     }
  }

}





int GUIMAIL_SendMail(unsigned char *ToPreset,unsigned char *AtPreset,
                     unsigned char *TitlePreset,unsigned long mode)
{

 if (BBSSendWindow==NULL)
   {

     GlobalArraysP->BBSSendArray1[0]=GUI_String(364);
     GlobalArraysP->BBSSendArray1[1]=GUI_String(365);
     GlobalArraysP->BBSSendArray1[2]=NULL;
     GlobalArraysP->BBSSendArray2[0]=GUI_String(366);
     GlobalArraysP->BBSSendArray2[1]=GUI_String(480);
     GlobalArraysP->BBSSendArray2[2]=GUI_String(367);
     GlobalArraysP->BBSSendArray2[3]=NULL;

     FillHook(&HooksP->BBSSendHook,(void *) GUIMAIL_SendHook,NULL);
     FillHook(&HooksP->BBSSendSHook,(void *) GUIMAIL_SendStream,NULL);

     BBSSendWindow =
                 WindowObject,
                     MUIA_Window_Title, GUI_String(361),
                     MUIA_Window_ID   , MAKE_ID('B','B','S','S'),

                     WindowContents,

                       VGroup,
                           Child,ColGroup(2),
                             Child,Label(GUI_String(481)),
                             Child,msobject(0)=Cycle(GlobalArraysP->BBSSendArray1),
                             Child,Label(GUI_String(482)),
                             Child,msobject(1)=Cycle(GlobalArraysP->BBSSendArray2),
                             Child,Label2(GUI_String(368)),
                             Child,msobject(2)=String(NULL,12),
                             Child,Label2(GUI_String(369)),
                             Child,msobject(3)=String(NULL,80),
                             Child,Label2(GUI_String(370)),
                             Child,msobject(4)=String(NULL,80),
                             Child,Label2(GUI_String(448)),
                             Child,msobject(7)=PopaslObject,
                                     MUIA_Popstring_String,String(NULL,196),
                                     MUIA_Popstring_Button,PopButton(MUII_PopFile),
                                     ASLFR_TitleText,GUI_String(361),
                                     End,

                             End,
                           Child,msobject(5)=EditorObject,
                             MUIA_Frame,MUIV_Frame_String,
                             MUIA_Font,PcFont8,
                             MUIA_Editor_EditorType,0,
                             MUIA_Editor_InputMask,0xffffffff,
                             MUIA_Editor_FreeMoving,FALSE,
                             MUIA_Editor_Unprintable,0,
                             MUIA_Editor_GarbageEditor,FALSE,
                             MUIA_Editor_WordWrap,79,
                             MUIA_Editor_LineWrap,TRUE,
                             MUIA_Editor_PCFontKeymap,TRUE,
                             MUIA_Editor_Pages,1,
                             MUIA_Editor_BufferSize,20*1024,
                             End,

                           Child,MUI_NewObject(MUIC_Rectangle,
                             MUIA_Weight,1,
                             End,

                           Child,msobject(6)=SimpleButton(GUI_String(371)),


















                         End,
                     End;

    if (BBSSendWindow==NULL)
        {
            GUI_LowMemory();
            return(0);
        }

    DoMethod(Application,OM_ADDMEMBER,BBSSendWindow);

    {
     unsigned long i;
     for (i=0;i<8;++i)
      {
       if ( (i>=2) && (i<=4) ) set(msobject(i),MUIA_String_AdvanceOnCR,TRUE);
       set(msobject(i),MUIA_CycleChain,1);
      }

    }

    set(msobject(7),MUIA_String_AdvanceOnCR,TRUE);

    DoMethod(BBSSendWindow,MUIM_Notify,MUIA_Window_CloseRequest,TRUE,
             BBSSendWindow,3,MUIM_CallHook,&HooksP->BBSSendHook,0);


    DoMethod(msobject(6),MUIM_Notify,MUIA_Pressed,FALSE,
             msobject(6),3,MUIM_CallHook,&HooksP->BBSSendHook,1);

    DoMethod(msobject(1),MUIM_Notify,MUIA_Cycle_Active,MUIV_EveryTime,
             msobject(1),4,MUIM_CallHook,&HooksP->BBSSendHook,2,
             MUIV_TriggerValue);
    DoMethod(msobject(7),MUIM_Notify,MUIA_String_Acknowledge,MUIV_EveryTime,
             msobject(7),3,MUIM_CallHook,&HooksP->BBSSendHook,3);
   }


 set (BBSSendWindow,MUIA_Window_Open,FALSE);


 set (msobject(0),MUIA_Cycle_Active,(mode==1)?1:0);
 set (msobject(1),MUIA_Cycle_Active,0);
 set (msobject(2),MUIA_String_Contents,(ULONG) ToPreset);
 set (msobject(3),MUIA_String_Contents,(ULONG) AtPreset);
 set (msobject(4),MUIA_String_Contents,(ULONG) TitlePreset);
 set (msobject(7),MUIA_String_Contents,(ULONG) NULL);
 DoMethod(msobject(5),MUIM_Editor_ClearPage,0);

 set(msobject(1),MUIA_Disabled,(mode<2)?FALSE:TRUE);
 set(msobject(7),MUIA_Disabled,(mode<2)?FALSE:TRUE);
 set(msobject(5),MUIA_ShowMe,(mode>1)?FALSE:TRUE);
 GlobalArraysP->BBSSendMode=mode;
 set(BBSSendWindow,MUIA_Window_ActiveObject,(ULONG) msobject(2));
 set(BBSSendWindow,MUIA_Window_DefaultObject,(ULONG) msobject(5));
 set(BBSSendWindow,MUIA_Window_Open,TRUE);

 return(0);
}

void GUIMAIL_SendHook(struct Hook *MyHook,unsigned long *Param,void *Object,
                          void *Data)
{

 switch (*Param)
  {
   case 0:
    set (BBSSendWindow,MUIA_Window_Open,FALSE);
    break;
   case 1:
    {
     unsigned char target[12];
     unsigned char at[80];
     unsigned char title[80];
     unsigned char *filename,*p1,*p2,*p3;
     unsigned long type,format;

     get(msobject(0),MUIA_Cycle_Active,&type);
     get(msobject(1),MUIA_Cycle_Active,&format);
     get(msobject(2),MUIA_String_Contents,&p1);
     get(msobject(3),MUIA_String_Contents,&p2);
     get(msobject(4),MUIA_String_Contents,&p3);
     get(msobject(7),MUIA_String_Contents,&filename);
     CopyStringUpper(target,p1);
     CopyStringUpper(at,p2);
     CopyString(title,p3);
     MAIN_ConvertToPC(title);
     if (GlobalArraysP->BBSSendMode>1)
      {
       signed long mnr;
       mnr=GlobalArraysP->BBSSendMode-2;
       if (MAIL_CopyMail(MAIL_GetBoxCall(),target,at,type,NULL,mnr,NULL,title)==0)
        {
         GUI_DisplayEventWindow(GUI_String(495));
         break;
        }
       set(BBSSendWindow,MUIA_Window_Open,FALSE);
       GUIMAIL_RefreshList();
       break;
      }
     switch (format)
      {
       case 0:
        {
         signed long errcode;
         void *mymail;

         mymail=MAIL_SendMail(MAIL_GetBoxCall(),target,at,type,NULL);
         if (mymail==NULL)
          {
           GUI_DisplayEventWindow(GUI_String(495));
           break;
          }
         MAIL_SetMailTitle(mymail,title);

         errcode=DoMethod(msobject(5),MUIM_Editor_ExportStream,
                  mymail,0,MUIV_Editor_ImExMode_CR|MUIV_Editor_ImExMode_PCChar,
                  FALSE,&HooksP->BBSSendSHook);
         if (errcode!=MUIV_Editor_Return_OK)
          {
           switch (errcode)
            {
             case MUIV_Editor_Return_Disk_DiskError:
              GUI_DisplayEventWindow(GUI_String(498));
              break;
             case MUIV_Editor_Return_Disk_NoMemory:
              GUI_DisplayEventWindow(GUI_String(494));
              break;
             default:
              GUI_DisplayEventWindow(GUI_String(495));
              break;
            };
           MAIL_MarkAsIncomp(mymail);
           MAIL_CloseMail(mymail);
           break;
          }
         MAIL_CloseMail(mymail);
         set(BBSSendWindow,MUIA_Window_Open,FALSE);
         GUIMAIL_RefreshList();
         break;
        }
       case 1:
       case 2:
        {
         signed long errcode;
         errcode=MAIL_SendMailFile(type,format==1?0:1,
                                   (unsigned char *) MAIL_GetBoxCall(),
                                   target,at,title,filename,
                                   NULL,NULL,FALSE);
         if (errcode==0)
          {
           set(BBSSendWindow,MUIA_Window_Open,FALSE);
           GUIMAIL_RefreshList();
          }
         switch (errcode)
          {
           case -1:
             GUI_DisplayEventWindow(GUI_String(494));
             break;
           case -2:
             GUI_DisplayEventWindow(GUI_String(495));
             break;
           case -3:
             GUI_DisplayEventWindow(GUI_String(496));
             break;
           case -4:
             GUI_DisplayEventWindow(GUI_String(497));
             break;
           case -5:
             GUI_DisplayEventWindow(GUI_String(498));
             break;
          }
        }
      }

     break;
    }
   case 2:
    {
     unsigned long type;
     type=*(Param+1);
     if (type==0)
      {
       unsigned char *xptr;
       signed long errcode;
       BPTR fhand;
       set(msobject(5),MUIA_ShowMe,TRUE);
       get(Object,MUIA_String_Contents,&xptr);
       if ((fhand=Open(xptr,MODE_OLDFILE))==NULL) break;
       errcode=DoMethod(msobject(5),MUIM_Editor_ImportPage,
               fhand,0,0);
       Close(fhand);
      }
      else
      {
       set(msobject(5),MUIA_ShowMe,FALSE);
      }
     break;
    }
   case 3:
    {

     unsigned long format;
     get(msobject(1),MUIA_Cycle_Active,&format);

     if (format==0)
      {
       unsigned char *xptr;
       signed long errcode;
       BPTR fhand;
       get(Object,MUIA_String_Contents,&xptr);
       if ((fhand=Open(xptr,MODE_OLDFILE))==NULL) break;
       errcode=DoMethod(msobject(5),MUIM_Editor_ImportPage,
               fhand,0,0);
       Close(fhand);
      }
     break;
    }
  }

}

unsigned long GUIMAIL_SendStream(struct Hook *MyHook,unsigned long *Param,void *Object,
                          void *Data)
{
 unsigned long xxx;
 xxx=MAIL_WriteMail((void*) *(Param),(unsigned char *) *(Param+1),
                    (unsigned long) *(Param+2));
 if (xxx) return (-1);
 return (*(Param+2));
}


int GUIMAIL_ViewMail(unsigned long number, unsigned long mode)
{

 if (BBSViewWindow==NULL)
   {
     FillHook(&HooksP->BBSViewHook,(void *) GUIMAIL_ViewHook,NULL);
     FillHook(&HooksP->BBSViewSHook,(void *) GUIMAIL_ReceiveStream,NULL);

     BBSViewWindow =
                 WindowObject,
                     MUIA_Window_Title, GUI_String(484),
                     MUIA_Window_ID   , MAKE_ID('B','B','S','V'),

                     WindowContents,

                       VGroup,

                           Child,HGroup,

                               Child,Label(GUI_String(485)),
                               Child,mvobject(1)=TextObject,
                                    MUIA_Background,MUII_TextBack,
                                    MUIA_Frame,MUIV_Frame_Text,
                                    End,
                               Child,Label(GUI_String(486)),
                               Child,mvobject(2)=TextObject,
                                    MUIA_Background,MUII_TextBack,
                                    MUIA_Frame,MUIV_Frame_Text,
                                    End,
                               Child,Label(GUI_String(487)),
                               Child,mvobject(3)=TextObject,
                                    MUIA_Background,MUII_TextBack,
                                    MUIA_Frame,MUIV_Frame_Text,
                                    End,
                             End,

                           Child,HGroup,


                               Child,Label(GUI_String(488)),
                               Child,mvobject(4)=TextObject,
                                    MUIA_Background,MUII_TextBack,
                                    MUIA_Frame,MUIV_Frame_Text,
                                    End,

                               Child,Label(GUI_String(489)),
                               Child,mvobject(5)=TextObject,
                                    MUIA_Background,MUII_TextBack,
                                    MUIA_Frame,MUIV_Frame_Text,
                                    End,

                               Child,Label(GUI_String(490)),
                               Child,mvobject(6)=TextObject,
                                    MUIA_Background,MUII_TextBack,
                                    MUIA_Frame,MUIV_Frame_Text,
                                    End,

                               Child,Label(GUI_String(491)),
                               Child,mvobject(7)=TextObject,
                                    MUIA_Background,MUII_TextBack,
                                    MUIA_Frame,MUIV_Frame_Text,
                                    End,
                               Child,Label(GUI_String(492)),
                               Child,mvobject(8)=TextObject,                                   MUIA_Text_SetMin,FALSE,
                                    MUIA_Background,MUII_TextBack,
                                    MUIA_Frame,MUIV_Frame_Text,
                                    End,
                              End,

                           Child,HGroup,
                               Child,Label(GUI_String(493)),
                               Child,mvobject(9)=TextObject,
                                    MUIA_Background,MUII_TextBack,
                                    MUIA_Frame,MUIV_Frame_Text,
                                    End,
                              End,
                           /*Von an @Typ/Status Datum BID Nachricht# Titel*/


                           Child,HGroup,
                             Child,Label2(GUI_String(448)),
                             Child,mvobject(11)=PopaslObject,
                                     MUIA_Popstring_String,String(NULL,196),
                                     MUIA_Popstring_Button,PopButton(MUII_PopFile),
                                     ASLFR_TitleText,GUI_String(361),
                                     End,
                             
                             End,

                           Child,mvobject(10)=EditorObject,
                               MUIA_Frame,MUIV_Frame_String,
                               MUIA_Font,PcFont8,
                               MUIA_Editor_EditorType,1,
                               MUIA_Editor_InputMask,0xffffffff,
                               MUIA_Editor_FreeMoving,FALSE,
                               MUIA_Editor_Unprintable,0,
                               MUIA_Editor_PCFontKeymap,TRUE,
                               MUIA_Editor_Pages,1,
                               MUIA_Editor_BufferSize,40*1024,
                               End,

                           Child,MUI_NewObject(MUIC_Rectangle,
                             MUIA_Weight,1,
                             End,

                           Child,mvobject(0)=SimpleButton(GUI_String(483)),


                         End,
                     End;

    if (BBSViewWindow==NULL)
        {
            GUI_LowMemory();
            return(0);
        }

    DoMethod(Application,OM_ADDMEMBER,BBSViewWindow);

    {
     unsigned long i;
     for (i=0;i<12;++i)
      {
       if ( (i>0) && (i<10) ) continue;
       set(mvobject(i),MUIA_CycleChain,1);
      }

    }


    set(mvobject(11),MUIA_String_AdvanceOnCR,TRUE);

    DoMethod(BBSViewWindow,MUIM_Notify,MUIA_Window_CloseRequest,TRUE,
             BBSViewWindow,3,MUIM_CallHook,&HooksP->BBSViewHook,0);


    DoMethod(mvobject(0),MUIM_Notify,MUIA_Pressed,FALSE,
             mvobject(0),3,MUIM_CallHook,&HooksP->BBSViewHook,1);
   }


 set (BBSViewWindow,MUIA_Window_DefaultObject,(ULONG) mvobject(10));


 set (BBSViewWindow,MUIA_Window_Open,FALSE);

 GlobalArraysP->BBSViewMode=mode;
 GlobalArraysP->BBSViewMail=number;
  {
   void *vmail;
   if ((vmail=MAIL_OpenMail(number,NULL))==NULL) return(0);
   if (vmail== ((void *)-1 )) return(0);

   set(mvobject(1),MUIA_Text_Contents,(ULONG) MAIL_GetMailFm(vmail));
   set(mvobject(2),MUIA_Text_Contents,(ULONG) MAIL_GetMailTo(vmail));
   set(mvobject(3),MUIA_Text_Contents,(ULONG) MAIL_GetMailAt(vmail));

   {
    unsigned char lux[90];
    set(mvobject(6),MUIA_Text_Contents,(ULONG) MAIL_GetMailBid(vmail));
    MAIL_GetMailStatusTxt(vmail,lux);
    set(mvobject(4),MUIA_Text_Contents,(ULONG) lux);
    MAIL_GetMailDateTxt(vmail,lux);
    set(mvobject(5),MUIA_Text_Contents,(ULONG) lux);
    GUI_LongToString(lux,number,10000000,1);
    set(mvobject(7),MUIA_Text_Contents,(ULONG) lux);
    GUI_LongToString(lux,MAIL_GetMailBytes(vmail),10000000,1);
    set(mvobject(8),MUIA_Text_Contents,(ULONG) lux);
    CopyString(lux,MAIL_GetMailTitle(vmail));
    MAIN_ConvertToAmiga(lux);
    set(mvobject(9),MUIA_Text_Contents,(ULONG) lux);

   }

   {
    const unsigned char *c1p,*c2p;
    unsigned long ms;
    c1p=MAIL_GetMailTo(vmail);
    c2p=MAIL_GetBoxCall();
    ms=MAIL_GetMailStatus(vmail);
    if (ms&1)
     {
      while ( *(c1p)==*(c2p) )
       {
        if (*(c1p)=='\0')
         {
          MAIL_MarkAsRead(vmail);
          break;
         }
        ++c1p;++c2p;
       }
     }
     else
     {
      MAIL_MarkAsRead(vmail);
     }
   }

   set(mvobject(10),MUIA_ShowMe,(mode==0)?TRUE:FALSE);

   if (mode==0)

   /* show non binary mail */
    {
     signed long errcode;
     errcode=DoMethod(mvobject(10),MUIM_Editor_ImportStream,
                    vmail,0,MUIV_Editor_ImExMode_CR|MUIV_Editor_ImExMode_PCChar,
                    &HooksP->BBSViewSHook);

    }

   MAIL_CloseMail(vmail);
  }


 set(BBSViewWindow,MUIA_Window_ActiveObject,(ULONG) mvobject(10));
 set(BBSViewWindow,MUIA_Window_Open,TRUE);

 return(0);
}

void GUIMAIL_ViewHook(struct Hook *MyHook,unsigned long *Param,void *Object,
                          void *Data)
{

 switch (*Param)
  {
   case 0:
    set (BBSViewWindow,MUIA_Window_Open,FALSE);
    break;
   case 1:
    {
     unsigned char *fname;
     unsigned long mmode,mnumber;
     get(mvobject(11),MUIA_String_Contents,&fname);

     mmode=GlobalArraysP->BBSViewMode;
     mnumber=GlobalArraysP->BBSViewMail;

     if (mmode==0)
      {
       BPTR fileh;
       signed long errcode;

       fileh=Open(fname,MODE_NEWFILE);
       if (fileh==NULL)
        {
         GUI_DisplayEventWindow(GUI_String(503));
         break;
        }

       errcode=DoMethod(mvobject(10),MUIM_Editor_ExportPage,
                      fileh,0,MUIV_Editor_ImExMode_LF|MUIV_Editor_ImExMode_AmChar,
                      FALSE);

       if (errcode!=0)
        {
         GUI_DisplayEventWindow(GUI_String(503));
         Close(fileh);
         break;
        }
       Close (fileh);
      }
      else
      {
       signed long errcode;
       errcode=MAIL_ExtractMailFile(fname,mnumber,FALSE);
       if (errcode!=0)
        {
         GUI_DisplayEventWindow(GUI_String(503));
         break;
        }
      }
     set (BBSViewWindow,MUIA_Window_Open,FALSE);
     break;
    }
  }

}

unsigned long GUIMAIL_ReceiveStream(struct Hook *MyHook,unsigned long *Param,void *Object,
                          void *Data)
{
 return(MAIL_ReadMail((void*) *(Param),(unsigned char *) *(Param+1),
                    (unsigned long) *(Param+2)));
}




#else /*DISABLE_BBS*/

int GUIMAIL_Mailbox(void)
 {
  return(0);
 }
#endif /*DISABLE_BBS*/
