/*ProfiPacket - packet radio terminal program
  Copyright (C) 1999  Alexander Feigl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Author:

  Alexander Feigl
  Burachstrae 51

  D-88250 Weingarten

  Mail : Alexander.Feigl@gmx.de
*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif


#include "GUIProtos.h"
#include "global.h"
#include "Preferences.h"

#include <libraries/mui.h>

#include <devices/timer.h>

#include <exec/lists.h>

#include <exec/memory.h>
#include <dos/exall.h>

#include <clib/muimaster_protos.h>
#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/alib_protos.h>
#include <clib/intuition_protos.h>

#include <utility/hooks.h>

#include <libraries/asl.h>


#ifdef __GNUC__


extern void *DOSBase;
extern void *SysBase;
extern void *IntuitionBase;
extern void *UtilityBase;
extern void *MUIMasterBase;

#define NO_INLINE_STDARG
#include <inline/muimaster.h>
#include <inline/dos.h>
#include <inline/exec.h>
#include <inline/intuition.h>
#include <inline/utility.h>
#endif

#ifndef MAKE_ID
#define MAKE_ID(a,b,c,d) ((ULONG) (a)<<24 | (ULONG) (b)<<16 | (ULONG) (c)<<8 | (ULONG) (d))
#endif

#define prefo(obj) GlobalArraysP->PrefObjects[obj]

void FillHookA4(void);
void FillHook(struct Hook *MyHook,void *Function,void *FunctionData);

/* Hookfunc: struct Hook *MyHook,void *Param,void *Object,void *Data) */

void GUIPREF_CloseWindow(struct Hook *MyHook,unsigned long *Param,void *Object,
                         void *Data);

void GUIPREF_PrefTNCHook(struct Hook *MyHook,unsigned long *Param,void *Object,
                         void *Data);

void GUIPREF_PrefCallHook(struct Hook *MyHook,unsigned long *Param,void *Object,
                         void *Data);

void GUIPREF_PrefCMsgHook(struct Hook *MyHook,unsigned long *Param,void *Object,
                         void *Data);

void GUIPREF_PrefAudioHook(struct Hook *MyHook,unsigned long *Param,void *Object,
                         void *Data);


#include "Editor.h"

#define EditorObject NewObject(EditorClass->mcc_Class,NULL
#define EditorPrefObject NewObject(EditorPrefClass->mcc_Class,NULL


void GUI_Preferences(void)
 {
  if (PrefWindow==NULL)
   {


 {
  unsigned char **xptr;

  xptr=GlobalArraysP->PrefArray1;


  *(xptr++)=GUI_String(397);
  *(xptr++)=GUI_String(431);
  *(xptr++)=GUI_String(401);
  *(xptr++)=GUI_String(477);
  *(xptr++)=GUI_String(540);
#ifndef DISABLE_BBS
  *(xptr++)=GUI_String(379);
#endif
  *(xptr++)=GUI_String(578);
  *(xptr++)=GUI_String(438);
  *(xptr++)="Editor";
  *(xptr++)=NULL;


  xptr=GlobalArraysP->PrefArray2;
  *(xptr++)=GUI_String(387);
  *(xptr++)=GUI_String(388);
  *(xptr++)=GUI_String(389);
  *(xptr++)=GUI_String(390);
  *(xptr++)=GUI_String(391);
  *(xptr++)=NULL;

   {
    unsigned long i;
    xptr=GlobalArraysP->PrefArray8;
    for (i=580;i<590;++i)
     {
      *(xptr++)=GUI_String(i);
     }
    *(xptr++)=NULL;
   }

  GlobalArraysP->PrefArray9[0]=GUI_String(591);
  GlobalArraysP->PrefArray9[1]=GUI_String(592);
  GlobalArraysP->PrefArray9[2]=NULL;

  GlobalArraysP->PrefArray10[0]=GUI_String(594);
  GlobalArraysP->PrefArray10[1]=GUI_String(604);
  GlobalArraysP->PrefArray10[2]=GUI_String(595);
  GlobalArraysP->PrefArray10[3]=NULL;

  GlobalArraysP->PrefArray11[0]=GUI_String(598);
  GlobalArraysP->PrefArray11[1]=GUI_String(599);
  GlobalArraysP->PrefArray11[2]=GUI_String(600);
  GlobalArraysP->PrefArray11[3]=GUI_String(601);
  GlobalArraysP->PrefArray11[4]=NULL;



  GlobalArraysP->PrefArray3[0]=GUI_String(392);
  GlobalArraysP->PrefArray3[1]=GUI_String(393);
  GlobalArraysP->PrefArray3[2]=NULL;

  GlobalArraysP->PrefArray6[0]=GUI_String(434);
  GlobalArraysP->PrefArray6[1]=GUI_String(541);
  GlobalArraysP->PrefArray6[2]=NULL;

  GlobalArraysP->PrefArray7[0]=GUI_String(543);
  GlobalArraysP->PrefArray7[1]=GUI_String(544);
  GlobalArraysP->PrefArray7[2]=GUI_String(545);
  GlobalArraysP->PrefArray7[3]=NULL;

 }
     {
      unsigned long i;
      for (i=0;i<8;++i)
       {
        GlobalArraysP->PrefArray4[i]=GUI_String(409+i);
        GlobalArraysP->PrefArray5[i]=GUI_String(417+i);
       }
      GlobalArraysP->PrefArray4[8]=NULL;
      GlobalArraysP->PrefArray5[8]=NULL;
     }

     FillHook(&HooksP->PrefCloseHook,(void *) GUIPREF_CloseWindow,NULL);
     FillHook(&HooksP->PrefTNCHook,(void *) GUIPREF_PrefTNCHook,NULL);
     FillHook(&HooksP->PrefCallHook,(void *) GUIPREF_PrefCallHook,NULL);
     FillHook(&HooksP->PrefCMsgHook,(void *) GUIPREF_PrefCMsgHook,NULL);
     FillHook(&HooksP->PrefAudioHook,(void *) GUIPREF_PrefAudioHook,NULL);

      {
       unsigned long i;
       for (i=0;i<127;++i) prefo(i)=NULL;
      }
     PrefWindow =
                 WindowObject,
                     MUIA_Window_Title, GUI_String(378),
                     MUIA_Window_ID   , MAKE_ID('P','R','E','F'),
                     MUIA_HelpNode,"Preferences",
                     WindowContents,

                       VGroup,
                         Child, prefo(55)=RegisterGroup(&GlobalArraysP->PrefArray1),
                           MUIA_Register_Frame,TRUE,

                           /* TNC Gruppe */

                           Child,VGroup,
                                 Child,HGroup,
                                   MUIA_HelpNode,"Preferences_HardwareUnit",
                                   Child,Label2(GUI_String(54)),
                                   Child,
                                     prefo(9)= /* Hardunit*/
                                         Slider(1,8,2),
                                   End,
                                 Child,ColGroup(2),
                                   MUIA_HelpNode,"Preferences_Device",
                                   Child,Label2(GUI_String(63)),
                                   Child,
                                     prefo(10)= /* Devname*/
                                         String(NULL,32),

                                   Child,Label2(GUI_String(66)),
                                   Child,
                                      prefo(11)= /* Devunit*/
                                         StringObject,
                                           MUIA_Frame,MUIV_Frame_String,
                                           MUIA_String_Accept,"0123456789",
                                           MUIA_String_MaxLen,8,
                                           MUIA_String_Integer,0,
                                           End,

                                   Child,Label2(GUI_String(67)),
                                   Child,
                                      prefo(12)= /* Devflags*/
                                         StringObject,
                                           MUIA_Frame,MUIV_Frame_String,
                                           MUIA_String_Accept,"0123456789",
                                           MUIA_String_MaxLen,8,
                                           MUIA_String_Integer,0,
                                           End,

                                   Child,Label2(GUI_String(68)),
                                   Child,
                                      prefo(13)= /*Devbaud*/
                                         StringObject,
                                           MUIA_Frame,MUIV_Frame_String,
                                           MUIA_String_Accept,"0123456789",
                                           MUIA_String_MaxLen,6,
                                           MUIA_String_Integer,0,
                                           End,
                                   End,
                                 Child,ColGroup(2),
                                   MUIA_HelpNode,"Preferences_TNCSettings",
                                   Child,Label2(GUI_String(65)),
                                   Child,
                                      prefo(14)= /*Prefix*/
                                         String(NULL,8),

                                   Child,Label2(GUI_String(398)),
                                   Child,
                                      prefo(15)= /*Descript*/
                                         String(NULL,12),

                                   Child,Label2(GUI_String(64)),
                                   Child,
                                      prefo(16)= /*Glob Mycall*/
                                         String(NULL,10),

                                   Child,Label2(GUI_String(399)),
                                   Child,
                                      prefo(17)= /*TNC channels*/
                                         Slider(0,40,0),

                                   Child,Label2(GUI_String(69)),
                                   Child,
                                      prefo(18)= /*Callset*/
                                         Slider(1,8,1),

                                   Child,Label2(GUI_String(400)),
                                   Child,
                                      prefo(19)= /*Assigned channels*/
                                         Slider(0,40,0),

                                   Child,Label2(GUI_String(541)),
                                   Child,
                                      prefo(61)= /*Send beacon*/
                                         Cycle(GlobalArraysP->PrefArray7),
                                   Child,Label2(GUI_String(546)),
                                   Child,
                                      prefo(62)= /*Beacon path*/
                                         String(NULL,80),



                                 End,
                                 End,


                           /* Callset gruppe */

                           Child,ColGroup(2),

                                MUIA_HelpNode,"Preferences_Callsets",
                                Child,Label2(GUI_String(446)),
                                Child,prefo(39)=Slider(1,8,2),

                                Child,Label2(GUI_String(432)),
                                Child,prefo(40)=String(NULL,10),

                                Child,Label2(GUI_String(433)),
                                Child,prefo(41)=String(NULL,32),


                             End,

                           /* GUI gruppe */

                           Child,VGroup,

                              Child,ColGroup(4),

                                MUIA_HelpNode,"Preferences_GUISwitch",

                                /* Numlock */
                                Child,Label(GUI_String(326)),
                                Child,prefo(20)=Cycle(GlobalArraysP->PrefArray3),

                                /* Insertmode */
                                Child,Label(GUI_String(327)),
                                Child,prefo(21)=Cycle(GlobalArraysP->PrefArray3),


                                /* Buffersave */
                                Child,Label(GUI_String(330)),
                                Child,prefo(24)=Cycle(GlobalArraysP->PrefArray3),

                                /* Monitor mode */
                                Child,Label(GUI_String(331)),
                                Child,prefo(25)=Cycle(GlobalArraysP->PrefArray3),

                                End,
                              Child,ColGroup(2),
                                /* Messagewindowsecs */
                                MUIA_HelpNode,"Preferences_GUIMisc",
                                Child,Label2(GUI_String(329)),
                                Child,prefo(22)=Slider(1,15,6),

                                /* Datacollector */
                                Child,Label2(GUI_String(328)),
                                Child,prefo(23)=Slider(50,600,300),
                                End,
                              Child,ColGroup(2),
                                MUIA_HelpNode,"Preferences_GUIBuffers",

                                /* Editbuf */
                                Child,Label2(GUI_String(406)),
                                Child,prefo(26)=Slider(4,1024,4),
                                /* QSOBuf */
                                Child,Label2(GUI_String(407)),
                                Child,prefo(27)=Slider(4,1024,10),
                                /* Monbuf */
                                Child,Label2(GUI_String(408)),
                                Child,prefo(28)=Slider(4,1024,20),



                                End,
                              End,
                            Child,VGroup,
                              Child,ColGroup(3),
                                MUIA_HelpNode,"Preferences_GUIColors",
                                /* Sysop*/
                                Child,Label(GUI_String(402)),
                                Child,prefo(29)=Cycle(GlobalArraysP->PrefArray4),
                                Child,prefo(30)=Cycle(GlobalArraysP->PrefArray5),
                                /* User*/
                                Child,Label(GUI_String(403)),
                                Child,prefo(31)=Cycle(GlobalArraysP->PrefArray4),
                                Child,prefo(32)=Cycle(GlobalArraysP->PrefArray5),
                                /* Link*/
                                Child,Label(GUI_String(404)),
                                Child,prefo(33)=Cycle(GlobalArraysP->PrefArray4),
                                Child,prefo(34)=Cycle(GlobalArraysP->PrefArray5),
                                /* Special*/
                                Child,Label(GUI_String(405)),
                                Child,prefo(35)=Cycle(GlobalArraysP->PrefArray4),
                                Child,prefo(36)=Cycle(GlobalArraysP->PrefArray5),
                                End,
                              Child,ColGroup(4),
                                MUIA_HelpNode,"Preferences_GUIWindows",
                                /* Edit weigth */
                                Child,Label2(GUI_String(425)),
                                Child,prefo(37)=Slider(20,150,20),
                                /* Monitor weigth */
                                Child,Label2(GUI_String(426)),
                                Child,prefo(38)=Slider(20,150,20),

                                Child,Label2(GUI_String(478)),
                                Child,prefo(53)=Slider(20,150,20),
                                Child,Label2(GUI_String(479)),
                                Child,prefo(54)=Slider(20,150,20),
                                End,
                              End,

                           /* Monitor group */

                           Child, prefo(60)=RegisterGroup(&GlobalArraysP->PrefArray6),
                             MUIA_Register_Frame,TRUE,
                              /* Spy group */
                              Child,ColGroup(2),
                                   MUIA_HelpNode,"Preferences_Spys",
                                   Child,Label2(GUI_String(435)),
                                   Child,prefo(42)=Slider(0,20,0),

                                   Child,Label(GUI_String(436)),
                                   Child,prefo(43)=Cycle(&GlobalArraysP->PrefArray3),

                                   Child,Label2(GUI_String(437)),
                                   Child,prefo(44)=Slider(1,7,1),
                              End,
                              /*Beacon group*/
                              Child,ColGroup(2),
                                   MUIA_HelpNode,"Preferences_Beacon",
                                   Child,Label2(GUI_String(547)),
                                   Child,prefo(63)=
                                        Slider(15,120,1),
                                   Child,Label(GUI_String(548)),
                                   Child,prefo(64)=
                                        Cycle(&GlobalArraysP->PrefArray3),
                                   Child,Label(GUI_String(549)),
                                   Child,prefo(65)=
                                        Cycle(&GlobalArraysP->PrefArray3),
                                   Child,Label2(GUI_String(550)),
                                   Child,prefo(66)=
                                        String(NULL,160),
                                   Child,Label2(GUI_String(551)),
                                   Child,prefo(67)=
                                        String(NULL,80),
                              End,
                            End,
                           /* Mailbox group*/

#ifndef DISABLE_BBS

                           Child,ColGroup(2),
                                   MUIA_HelpNode,"Preferences_BBS",
                                   Child,
                                     Label2(GUI_String(380)),
                                    /*Mail lifetime*/
                                   Child,
                                     prefo(0)=
                                         Slider(0,128,5),                                      

                                   Child,
                                     Label(GUI_String(381)),
                                    /*Max # of mails*/
                                   Child,
                                     prefo(1)=
                                         Slider(0,4096,0),

                                   Child,
                                     Label1(GUI_String(382)),
                                    /*Sysop mail calls*/
                                   Child,
                                     prefo(2)=
                                         Cycle(&GlobalArraysP->PrefArray2),


                                   Child,
                                     Label1(GUI_String(383)),
                                    /*Redirect sysop mails*/
                                   Child,
                                     prefo(3)=
                                         Cycle(&GlobalArraysP->PrefArray3),

                                   Child,
                                     Label1(GUI_String(384)),
                                    /*Show maillist in mailmacro*/
                                   Child,
                                     prefo(4)=
                                         Cycle(&GlobalArraysP->PrefArray3),

                                   Child,
                                     Label1(GUI_String(385)),
                                    /*Lock external sysop mail access*/
                                   Child,
                                     prefo(5)=
                                         Cycle(&GlobalArraysP->PrefArray3),


                                   Child,
                                     Label1(GUI_String(512)),
                                    /*P-Mail only once*/
                                   Child,
                                     prefo(58)=
                                         Cycle(&GlobalArraysP->PrefArray3),

                                   Child,
                                     Label1(GUI_String(513)),
                                    /*Full BBS*/
                                   Child,
                                     prefo(59)=
                                         Cycle(&GlobalArraysP->PrefArray3),


                                   Child,
                                     Label2(GUI_String(386)),
                                    /*Box identifier*/
                                   Child,
                                     prefo(6)=String(NULL,8),
                                   
                                   Child,
                                     Label2(GUI_String(510)),
                                    /*Box QTH */
                                   Child,
                                     prefo(56)=String(NULL,16),

                                   Child,
                                     Label2(GUI_String(511)),
                                    /*Box H-Route*/
                                   Child,
                                     prefo(57)=String(NULL,64),


                                   End,

#endif
                             /* Audio group */

                           Child,
                                 VGroup,
                                   Child,
                                     HGroup,
                                       Child,prefo(68)=MUI_NewObject(MUIC_Listview,
                                              MUIA_Background,MUII_ListBack,
                                              MUIA_Frame,MUIV_Frame_InputList,
                                              MUIA_FrameTitle,GUI_String(579),
                                                MUIA_Listview_List,
                                                  MUI_NewObject(MUIC_List,
                                                  MUIA_List_Active,1,
                                                  MUIA_List_SourceArray,GlobalArraysP->PrefArray8,
                                                End,
                                             End,

                                       Child,VGroup,
                                         Child,VSpace(0),
                                         Child,ColGroup(2),
                                           Child,Label(GUI_String(590)),
                                           Child,prefo(69)= /* Audio target */
                                                   Cycle(GlobalArraysP->PrefArray9),
                                           Child,Label(GUI_String(593)),
                                           Child,prefo(70)= /* Audio type */
                                                   Cycle(GlobalArraysP->PrefArray10),
                                           Child,Label(GUI_String(596)),
                                           Child,prefo(71)=PopaslObject, /* Audio filename*/
                                                   MUIA_Popstring_String,String(NULL,196),
                                                   MUIA_Popstring_Button,PopButton(MUII_PopFile),
                                                   ASLFR_TitleText,GUI_String(596),
                                                 End,
                                           Child,Label(GUI_String(597)),
                                           Child,prefo(72)= /* Audio level */
                                                   Cycle(GlobalArraysP->PrefArray11),
                                           Child,Label(GUI_String(602)),
                                           Child,prefo(73)=
                                                   Slider(0,23,11),
                                           Child,Label(GUI_String(603)),
                                           Child,prefo(74)=
                                                   Slider(0,23,11),
                                           End,
                                         Child,VSpace(0),

                                       End,
                                     End,

                                 End,

                             /* Misc group */

                           Child,VGroup,
                           Child,ColGroup(2),
                                 MUIA_HelpNode,"Preferences_Path",
                                 Child,Label2(GUI_String(439)),
                                 Child,prefo(45)=PopaslObject,
                                        MUIA_Popstring_String,String(NULL,196),
                                        MUIA_Popstring_Button,PopButton(MUII_PopDrawer),
                                        ASLFR_TitleText,GUI_String(439),
                                        ASLFR_DrawersOnly,TRUE,
                                        End,

                                 Child,Label2(GUI_String(440)),
                                 Child,prefo(46)=PopaslObject,
                                        MUIA_Popstring_String,String(NULL,196),
                                        MUIA_Popstring_Button,PopButton(MUII_PopDrawer),
                                        ASLFR_TitleText,GUI_String(440),
                                        ASLFR_DrawersOnly,TRUE,
                                        End,
                                 End,
                           Child,ColGroup(2),
                                 MUIA_HelpNode,"Preferences_Huffman",
                                 Child,Label(GUI_String(441)),
                                 Child,prefo(47)=Cycle(&GlobalArraysP->PrefArray3),

                                 Child,Label(GUI_String(442)),
                                 Child,prefo(48)=Cycle(&GlobalArraysP->PrefArray3),
                                 End,
                           Child,ColGroup(2),
                                 MUIA_HelpNode,"Preferences_ConnectMessage",
                                 Child,Label2(GUI_String(443)),
                                 Child,prefo(49)=Slider(1,16,2),

                                 Child,Label2(GUI_String(443)),
                                 Child,prefo(50)=String(NULL,80),

                                 Child,Label2(GUI_String(444)),
                                 Child,prefo(51)=Slider(0,16,2),

                                 Child,Label2(GUI_String(445)),
                                 Child,prefo(52)=Slider(0,3600,0),


                             End,
                           End,
                           Child,prefo(127)=EditorPrefObject,
                             End,

                           End,
                         Child, HGroup,
                           Child,prefo(7)=SimpleButton(GUI_String(262)),
                           Child,prefo(8)=SimpleButton(GUI_String(16)),
                           End,

                       End,
                     End;

    if (PrefWindow==NULL)
        {
            GUI_LowMemory();
            return;
        }

    DoMethod(Application,OM_ADDMEMBER,PrefWindow);


    DoMethod(prefo(127),MUIM_Settingsgroup_ConfigToGadgets,PrefDataspace);


     {
      unsigned long i;
      for (i=0;i<75;++i)
       {
        if (prefo(i)!=NULL) set(prefo(i),MUIA_CycleChain,1);
       }
     }


    DoMethod(PrefWindow,MUIM_Notify,MUIA_Window_CloseRequest,TRUE,
             PrefWindow,3,MUIM_CallHook,&HooksP->PrefCloseHook,TRUE);

    DoMethod(prefo(7),MUIM_Notify,MUIA_Pressed,FALSE,
             PrefWindow,3,MUIM_CallHook,&HooksP->PrefCloseHook,TRUE);
    DoMethod(prefo(8),MUIM_Notify,MUIA_Pressed,FALSE,
             PrefWindow,3,MUIM_CallHook,&HooksP->PrefCloseHook,FALSE);


    /* Install TNC notifications */

    DoMethod(prefo(9),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefTNCHook
             ,0,MUIV_TriggerValue);
    DoMethod(prefo(10),MUIM_Notify,MUIA_String_Contents,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefTNCHook
             ,1,MUIV_TriggerValue);
    DoMethod(prefo(11),MUIM_Notify,MUIA_String_Contents,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefTNCHook
             ,2,MUIV_TriggerValue);
    DoMethod(prefo(12),MUIM_Notify,MUIA_String_Contents,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefTNCHook
             ,3,MUIV_TriggerValue);
    DoMethod(prefo(13),MUIM_Notify,MUIA_String_Contents,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefTNCHook
             ,4,MUIV_TriggerValue);
    DoMethod(prefo(14),MUIM_Notify,MUIA_String_Contents,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefTNCHook
             ,5,MUIV_TriggerValue);
    DoMethod(prefo(15),MUIM_Notify,MUIA_String_Contents,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefTNCHook
             ,6,MUIV_TriggerValue);
    DoMethod(prefo(16),MUIM_Notify,MUIA_String_Contents,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefTNCHook
             ,7,MUIV_TriggerValue);
    DoMethod(prefo(17),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefTNCHook
             ,8,MUIV_TriggerValue);
    DoMethod(prefo(18),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefTNCHook
             ,9,MUIV_TriggerValue);
    DoMethod(prefo(19),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefTNCHook
             ,10,MUIV_TriggerValue);

    DoMethod(prefo(61),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefTNCHook
             ,11,MUIV_TriggerValue);
    DoMethod(prefo(62),MUIM_Notify,MUIA_String_Contents,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefTNCHook
             ,12,MUIV_TriggerValue);


    /* Callset notifies */


    DoMethod(prefo(39),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefCallHook,
             0,MUIV_TriggerValue);

    DoMethod(prefo(40),MUIM_Notify,MUIA_String_Contents,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefCallHook,
             1,MUIV_TriggerValue);

    DoMethod(prefo(41),MUIM_Notify,MUIA_String_Contents,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefCallHook,
             2,MUIV_TriggerValue);


    /* Install GUI notiy*/

    DoMethod(prefo(20),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.NumLock);
    DoMethod(prefo(21),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.InsertMode);
    DoMethod(prefo(24),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.BufferSave);
    DoMethod(prefo(25),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.MonitorMode);
    DoMethod(prefo(22),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.MessageWindowSecs);
    DoMethod(prefo(23),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.DataCollectorTime);
    DoMethod(prefo(26),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.EditBuffersize);
    DoMethod(prefo(27),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.QSOBuffersize);
    DoMethod(prefo(28),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.MonitorBuffersize);
    DoMethod(prefo(29),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.SysopANSIPen);
    DoMethod(prefo(30),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.SysopANSIStyle);
    DoMethod(prefo(31),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.UserANSIPen);
    DoMethod(prefo(32),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.UserANSIStyle);
    DoMethod(prefo(33),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.LinkANSIPen);
    DoMethod(prefo(34),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.LinkANSIStyle);
    DoMethod(prefo(35),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.SpecialANSIPen);
    DoMethod(prefo(36),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.SpecialANSIStyle);
    DoMethod(prefo(37),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.EditWeight);
    DoMethod(prefo(38),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.MonitorWeight);
    DoMethod(prefo(53),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.MonEditWeight);
    DoMethod(prefo(54),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.MonMonitorWeight);



    /* Install Beacon notifications */

    DoMethod(prefo(63),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.BeaconMinutes);
    DoMethod(prefo(64),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.BeaconOnlyMail);
    DoMethod(prefo(65),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.BeaconNoMessage);
    DoMethod(prefo(66),MUIM_Notify,MUIA_String_Contents,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteString,MUIV_TriggerValue,
             NewPref.BeaconLine);
    DoMethod(prefo(67),MUIM_Notify,MUIA_String_Contents,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteString,MUIV_TriggerValue,
             NewPref.BeaconMailLine);


    /* Install Spy notifications */

    DoMethod(prefo(42),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.MaxSpy);

    DoMethod(prefo(43),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.SpyAutoCompress);

    DoMethod(prefo(44),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.SpyAutoCompressFol);

#ifndef DISABLE_BBS


    /* Install BBS notifications */

    DoMethod(prefo(0),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.MailLifetime);
    DoMethod(prefo(1),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.MaxMails);
    DoMethod(prefo(2),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.SysopCallPeriod);
    DoMethod(prefo(3),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.RedirectMycalls);
    DoMethod(prefo(4),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.ShowMaillist);
    DoMethod(prefo(5),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.LockSysopMails);
    DoMethod(prefo(6),MUIM_Notify,MUIA_String_Contents,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteString,MUIV_TriggerValue,
             NewPref.BoxIdent);
    DoMethod(prefo(56),MUIM_Notify,MUIA_String_Contents,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteString,MUIV_TriggerValue,
             NewPref.BoxQTH);
    DoMethod(prefo(57),MUIM_Notify,MUIA_String_Contents,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteString,MUIV_TriggerValue,
             NewPref.BoxHRoute);
    DoMethod(prefo(58),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.PMailOnce);
    DoMethod(prefo(59),MUIM_Notify,MUIA_Cycle_Active,
             MUIV_EveryTime,PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.FullBBS);


#endif

    /* Install audio notifications */

    DoMethod(prefo(68),MUIM_Notify,MUIA_List_Active,MUIV_EveryTime,
             PrefWindow,4,MUIM_CallHook,&HooksP->PrefAudioHook,
             MUIV_TriggerValue,0);


    DoMethod(prefo(69),MUIM_Notify,MUIA_Cycle_Active,MUIV_EveryTime,
             PrefWindow,4,MUIM_CallHook,&HooksP->PrefAudioHook,
             MUIV_TriggerValue,1);


    DoMethod(prefo(70),MUIM_Notify,MUIA_Cycle_Active,MUIV_EveryTime,
             PrefWindow,4,MUIM_CallHook,&HooksP->PrefAudioHook,
             MUIV_TriggerValue,2);

    DoMethod(prefo(71),MUIM_Notify,MUIA_String_Contents,MUIV_EveryTime,
             PrefWindow,4,MUIM_CallHook,&HooksP->PrefAudioHook,
             MUIV_TriggerValue,3);

    DoMethod(prefo(72),MUIM_Notify,MUIA_Cycle_Active,MUIV_EveryTime,
             PrefWindow,4,MUIM_CallHook,&HooksP->PrefAudioHook,
             MUIV_TriggerValue,4);

    DoMethod(prefo(73),MUIM_Notify,MUIA_Numeric_Value,MUIV_EveryTime,
             PrefWindow,4,MUIM_CallHook,&HooksP->PrefAudioHook,
             MUIV_TriggerValue,5);


    DoMethod(prefo(74),MUIM_Notify,MUIA_Numeric_Value,MUIV_EveryTime,
             PrefWindow,4,MUIM_CallHook,&HooksP->PrefAudioHook,
             MUIV_TriggerValue,6);





    /* Install misc notifications */

    DoMethod(prefo(45),MUIM_Notify,MUIA_String_Contents,MUIV_EveryTime,
             PrefWindow,3,MUIM_WriteString,MUIV_TriggerValue,
             NewPref.SaveDir);

    DoMethod(prefo(46),MUIM_Notify,MUIA_String_Contents,MUIV_EveryTime,
             PrefWindow,3,MUIM_WriteString,MUIV_TriggerValue,
             NewPref.RemoteDir);

    DoMethod(prefo(47),MUIM_Notify,MUIA_Cycle_Active,MUIV_EveryTime,
             PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.EnableHuffman);

    DoMethod(prefo(48),MUIM_Notify,MUIA_Cycle_Active,MUIV_EveryTime,
             PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.HuffmanMonitor);

    DoMethod(prefo(51),MUIM_Notify,MUIA_Numeric_Value,MUIV_EveryTime,
             PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.ConnectMsgAutoNr);

    DoMethod(prefo(52),MUIM_Notify,MUIA_Numeric_Value,MUIV_EveryTime,
             PrefWindow,3,MUIM_WriteLong,MUIV_TriggerValue,
             &NewPref.ConnectMsgAutoTime);

    DoMethod(prefo(49),MUIM_Notify,MUIA_Numeric_Value,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefCMsgHook,
             0,MUIV_TriggerValue);

    DoMethod(prefo(50),MUIM_Notify,MUIA_String_Contents,
             MUIV_EveryTime,PrefWindow,4,MUIM_CallHook,&HooksP->PrefCMsgHook,
             1,MUIV_TriggerValue);

   }


  {
   unsigned long status;

   get(PrefWindow,MUIA_Window_Open,&status);
   if (status==TRUE) return;
  }

  CopyMem(&Preferences,&NewPref,sizeof(struct PPPreferences));

  /* set TNC values */

  set (prefo(9),MUIA_Numeric_Value,1);

  /* set Callset values */

  set (prefo(39),MUIA_Numeric_Value,1);

  /* set GUI values */

  nnset (prefo(20),MUIA_Cycle_Active,NewPref.NumLock);
  nnset (prefo(21),MUIA_Cycle_Active,NewPref.InsertMode);
  nnset (prefo(24),MUIA_Cycle_Active,NewPref.BufferSave);
  nnset (prefo(25),MUIA_Cycle_Active,NewPref.MonitorMode);
  nnset (prefo(22),MUIA_Numeric_Value,NewPref.MessageWindowSecs);
  nnset (prefo(23),MUIA_Numeric_Value,NewPref.DataCollectorTime);
  nnset (prefo(26),MUIA_Numeric_Value,NewPref.EditBuffersize);
  nnset (prefo(27),MUIA_Numeric_Value,NewPref.QSOBuffersize);
  nnset (prefo(28),MUIA_Numeric_Value,NewPref.MonitorBuffersize);
  nnset (prefo(29),MUIA_Cycle_Active,NewPref.SysopANSIPen);
  nnset (prefo(30),MUIA_Cycle_Active,NewPref.SysopANSIStyle);
  nnset (prefo(31),MUIA_Cycle_Active,NewPref.UserANSIPen);
  nnset (prefo(32),MUIA_Cycle_Active,NewPref.UserANSIStyle);
  nnset (prefo(33),MUIA_Cycle_Active,NewPref.LinkANSIPen);
  nnset (prefo(34),MUIA_Cycle_Active,NewPref.LinkANSIStyle);
  nnset (prefo(35),MUIA_Cycle_Active,NewPref.SpecialANSIPen);
  nnset (prefo(36),MUIA_Cycle_Active,NewPref.SpecialANSIStyle);
  nnset (prefo(37),MUIA_Numeric_Value,NewPref.EditWeight);
  nnset (prefo(38),MUIA_Numeric_Value,NewPref.MonitorWeight);
  nnset (prefo(53),MUIA_Numeric_Value,NewPref.MonEditWeight);
  nnset (prefo(54),MUIA_Numeric_Value,NewPref.MonMonitorWeight);

  /* set mailbox values*/

#ifndef DISABLE_BBS

  nnset (GlobalArraysP->PrefObjects[0],MUIA_Numeric_Value,NewPref.MailLifetime);
  nnset (GlobalArraysP->PrefObjects[1],MUIA_Numeric_Value,NewPref.MaxMails);
  nnset (GlobalArraysP->PrefObjects[2],MUIA_Cycle_Active,NewPref.SysopCallPeriod);
  nnset (GlobalArraysP->PrefObjects[3],MUIA_Cycle_Active,NewPref.RedirectMycalls);
  nnset (GlobalArraysP->PrefObjects[4],MUIA_Cycle_Active,NewPref.ShowMaillist);
  nnset (GlobalArraysP->PrefObjects[5],MUIA_Cycle_Active,NewPref.LockSysopMails);
  nnset (GlobalArraysP->PrefObjects[6],MUIA_String_Contents,(ULONG) NewPref.BoxIdent);
  nnset (GlobalArraysP->PrefObjects[56],MUIA_String_Contents,(ULONG) NewPref.BoxQTH);
  nnset (GlobalArraysP->PrefObjects[57],MUIA_String_Contents,(ULONG) NewPref.BoxHRoute);
  nnset (GlobalArraysP->PrefObjects[58],MUIA_Cycle_Active,NewPref.PMailOnce);
  nnset (GlobalArraysP->PrefObjects[59],MUIA_Cycle_Active,NewPref.FullBBS);

#endif

  /* set Beacon values */

  nnset (prefo(63),MUIA_Numeric_Value,NewPref.BeaconMinutes);
  nnset (prefo(64),MUIA_Cycle_Active,NewPref.BeaconOnlyMail);
  nnset (prefo(65),MUIA_Cycle_Active,NewPref.BeaconNoMessage);
  nnset (prefo(66),MUIA_String_Contents,(ULONG) NewPref.BeaconLine);
  nnset (prefo(67),MUIA_String_Contents,(ULONG) NewPref.BeaconMailLine);

  /* set Spy values */

  nnset (prefo(42),MUIA_Numeric_Value,NewPref.MaxSpy);
  nnset (prefo(43),MUIA_Cycle_Active,NewPref.SpyAutoCompress);
  nnset (prefo(44),MUIA_Numeric_Value,NewPref.SpyAutoCompressFol);

  /* set Misc values */

  nnset (prefo(45),MUIA_String_Contents,(ULONG) NewPref.SaveDir);
  nnset (prefo(46),MUIA_String_Contents,(ULONG) NewPref.RemoteDir);
  nnset (prefo(47),MUIA_Cycle_Active,NewPref.EnableHuffman);
  nnset (prefo(48),MUIA_Cycle_Active,NewPref.HuffmanMonitor);
  nnset (prefo(51),MUIA_Numeric_Value,NewPref.ConnectMsgAutoNr);
  nnset (prefo(52),MUIA_Numeric_Value,NewPref.ConnectMsgAutoTime);

  set (prefo(49),MUIA_Numeric_Value,1);

  set (prefo(68),MUIA_List_Active,0);

  set (PrefWindow,MUIA_Window_Open,TRUE);

  return;
 }


void GUIPREF_CloseWindow(struct Hook *MyHook,unsigned long *Param,void *Object,
                         void *Data)
 {

  set (PrefWindow,MUIA_Window_Open,FALSE);
  if (*(Param)==FALSE) return;


  DoMethod(prefo(127),MUIM_Settingsgroup_GadgetsToConfig,PrefDataspace);


  if (GUI_CheckLeaveProg()==TRUE) return;

  CopyMem(&NewPref,&Preferences,sizeof(struct PPPreferences));
  PREF_SavePreferences();
  RestartProgram=1;
  DoMethod (Application,MUIM_Application_ReturnID,
            MUIV_Application_ReturnID_Quit);

  return;
 }

void GUIPREF_PrefTNCHook(struct Hook *MyHook,unsigned long *Param,void *Object,
                         void *Data)
 {
  struct TNCDevice *thisdev;
  unsigned long thisdevn;
  unsigned long trigger;

  unsigned char *ss,*ds;

  get (prefo(9),MUIA_Numeric_Value,&thisdevn);

  thisdev=&NewPref.Devices[thisdevn-1];

  trigger=*(Param+1);

  switch (*Param)
   {
    case 0:
     {
      unsigned long xv;
      get (prefo(18),MUIA_Numeric_Value,&xv);
      nnset (prefo(10),MUIA_String_Contents,(ULONG) thisdev->ExecDevice);
      nnset (prefo(11),MUIA_String_Integer,thisdev->ExecUnit);
      nnset (prefo(12),MUIA_String_Integer,thisdev->ExecFlags);
      nnset (prefo(13),MUIA_String_Integer,thisdev->ExecBaud);
      nnset (prefo(14),MUIA_String_Contents,(ULONG) thisdev->Prefix);
      nnset (prefo(15),MUIA_String_Contents,(ULONG) thisdev->Description);
      nnset (prefo(16),MUIA_String_Contents,(ULONG) thisdev->GlobalMycall);
      nnset (prefo(17),MUIA_Numeric_Value,thisdev->Channels);
      nnset (prefo(19),MUIA_Numeric_Value,thisdev->CallsetChannels[xv-1]);
      nnset (prefo(61),MUIA_Cycle_Active,thisdev->SendBeacon);
      nnset (prefo(62),MUIA_String_Contents,(ULONG) thisdev->BeaconPath);

      break;
     }
    case 1:
     {
      ss=(void *) trigger;
      ds=thisdev->ExecDevice;
      while (*ss!='\0') *(ds++)=*(ss++);
      *(ds)='\0';
      break;
     }
    case 2:
     {
      get(prefo(11),MUIA_String_Integer,&thisdev->ExecUnit);
      break;
     }
    case 3:
     {
      get(prefo(12),MUIA_String_Integer,&thisdev->ExecFlags);
      break;
     }
    case 4:
     {
      get(prefo(13),MUIA_String_Integer,&thisdev->ExecBaud);
      break;
     }
    case 5:
     {
      ss=(void *) trigger;
      ds=thisdev->Prefix;
      while (*ss!='\0') *(ds++)=*(ss++);
      *(ds)='\0';
      break;
     }
    case 6:
     {
      ss=(void *) trigger;
      ds=thisdev->Description;
      while (*ss!='\0') *(ds++)=*(ss++);
      *(ds)='\0';
      break;
     }
    case 7:
     {
      ss=(void *) trigger;
      ds=thisdev->GlobalMycall;
      while (*ss!='\0') *(ds++)=*(ss++);
      *(ds)='\0';
      break;
     }
    case 8:
     {
      thisdev->Channels=trigger;
      break;
     }
    case 9:
     {
      nnset (prefo(19),MUIA_Numeric_Value,thisdev->CallsetChannels[trigger-1]);
      break;
     }
    case 10:
     {
      unsigned long xv;
      get (prefo(18),MUIA_Numeric_Value,&xv);
      thisdev->CallsetChannels[xv-1]=trigger;
      break;
     }
    case 11:
     {
      thisdev->SendBeacon=trigger;
      break;
     }
    case 12:
     {
      CopyStringUpper(thisdev->BeaconPath,(unsigned char *) trigger);
     }
   }

 }

void GUIPREF_PrefCallHook(struct Hook *MyHook,unsigned long *Param,void *Object,
                         void *Data)
 {
  struct Callset *thiscall;
  unsigned long thiscalln;
  unsigned long trigger;

  unsigned char *ss,*ds;

  get (prefo(39),MUIA_Numeric_Value,&thiscalln);

  thiscall=&NewPref.Callsets[thiscalln-1];

  trigger=*(Param+1);

  switch (*Param)
   {
    case 0:
     {

      nnset (prefo(40),MUIA_String_Contents,(ULONG) thiscall->MyCall);
      nnset (prefo(41),MUIA_String_Contents,(ULONG) thiscall->ServerName);

      break;
     }
    case 1:
     {
      ss=(void *) trigger;
      ds=thiscall->MyCall;
      while (*ss!='\0') *(ds++)=*(ss++);
      *(ds)='\0';
      break;
     }
    case 2:
     {
      ss=(void *) trigger;
      ds=thiscall->ServerName;
      while (*ss!='\0') *(ds++)=*(ss++);
      *(ds)='\0';
      break;
     }
   }

 }

void GUIPREF_PrefCMsgHook(struct Hook *MyHook,unsigned long *Param,void *Object,
                         void *Data)
 {

  unsigned long thismsgn;
  unsigned long trigger;

  unsigned char *ss,*ds;

  get (prefo(49),MUIA_Numeric_Value,&thismsgn);

  trigger=*(Param+1);

  switch (*Param)
   {
    case 0:
     {

      nnset (prefo(50),MUIA_String_Contents,(ULONG) NewPref.ConnectMsg[thismsgn-1]);
      break;
     }
    case 1:
     {
      ss=(void *) trigger;
      ds=NewPref.ConnectMsg[thismsgn-1];
      while (*ss!='\0') *(ds++)=*(ss++);
      *(ds)='\0';
      break;
     }
   }

 }

void GUIPREF_PrefAudioHook(struct Hook *MyHook,unsigned long *Param,void *Object,
                         void *Data)
 {

  unsigned long thiseff;
  unsigned long trigger;

  unsigned char *ss,*ds;

  get (prefo(68),MUIA_List_Active,&thiseff);

  trigger=*(Param);

  switch (*(Param+1))
   {
    case 0:
     {
      nnset (prefo(69),MUIA_Cycle_Active,NewPref.AudioEffects[thiseff].EffectTarget);
      nnset (prefo(70),MUIA_Cycle_Active,NewPref.AudioEffects[thiseff].EffectType);
      nnset (prefo(71),MUIA_String_Contents,(ULONG) NewPref.AudioEffects[thiseff].EffectPath);
      nnset (prefo(72),MUIA_Cycle_Active,NewPref.AudioEffects[thiseff].EffectLevel);
      nnset (prefo(73),MUIA_Numeric_Value,NewPref.AudioEffects[thiseff].EffectStart);
      nnset (prefo(74),MUIA_Numeric_Value,NewPref.AudioEffects[thiseff].EffectStop);
      break;
     }
    case 1:
      NewPref.AudioEffects[thiseff].EffectTarget=trigger;
      break;
    case 2:
      NewPref.AudioEffects[thiseff].EffectType=trigger;
      break;

    case 3:
     {
      ss=(void *) trigger;
      ds=NewPref.AudioEffects[thiseff].EffectPath;
      while (*ss!='\0') *(ds++)=*(ss++);
      *(ds)='\0';
      break;
     }
    case 4:
      NewPref.AudioEffects[thiseff].EffectLevel=trigger;
      break;
    case 5:
      NewPref.AudioEffects[thiseff].EffectStart=trigger;
      break;
    case 6:
      NewPref.AudioEffects[thiseff].EffectStop=trigger;
      break;
   }

 }






