/*ProfiPacket - packet radio terminal program
  Copyright (C) 1999  Alexander Feigl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Author:

  Alexander Feigl
  Burachstrae 51

  D-88250 Weingarten

  Mail : Alexander.Feigl@gmx.de
*/


#ifndef INCLUDE_PREFERENCES

#define INCLUDE_PREFERENCES

struct TNCDevice
  {
   unsigned char  ExecDevice[32];
   unsigned long  ExecUnit;
   unsigned long  ExecFlags;
   unsigned long  ExecBaud;
   unsigned char  Prefix[8];
   unsigned char  Description[12];
   unsigned char  GlobalMycall[10];
   unsigned long  Channels;
   unsigned long  CallsetChannels[8];
   unsigned long  SendBeacon;
   unsigned char  BeaconPath[80];
  };

#define SENDBEACON_NEVER         0
#define SENDBEACON_NOTCONNECTED  1
#define SENDBEACON_EVERYTIME     2


struct Callset
  {
   unsigned char  MyCall[10];
   unsigned char  ServerName[32];
  };

struct AudioEffect
  {
   unsigned long  EffectTarget;
   unsigned long  EffectType;
   unsigned char  EffectPath[196];
   unsigned long  EffectLevel;
   unsigned long  EffectStart;
   unsigned long  EffectStop;
  };

struct PPPreferences
  {
   struct TNCDevice  Devices[8];
   struct Callset    Callsets[8];

   unsigned long  MaxSpy;
   unsigned long  NumLock;
   unsigned long  InsertMode;
   unsigned long  MessageWindowSecs;
   unsigned long  DataCollectorTime;
   unsigned long  BufferSave;
   unsigned long  MonitorMode;


   unsigned char  SaveDir[196];
   unsigned char  RemoteDir[196];
   unsigned long  EnableHuffman;
   unsigned long  HuffmanMonitor;
   unsigned char  ConnectMsg[16][80];
   unsigned long  ConnectMsgAutoTime;
   unsigned long  ConnectMsgAutoNr;
   unsigned long  SpyAutoCompress;
   unsigned long  SpyAutoCompressFol;
#ifndef DISABLE_BBS
   unsigned long  MailLifetime;
   unsigned long  MaxMails;
   unsigned long  SysopCallPeriod;
   unsigned long  RedirectMycalls;
   unsigned long  ShowMaillist;
   unsigned long  LockSysopMails;
   unsigned long  PMailOnce;
   unsigned long  FullBBS;
   unsigned char  BoxIdent[8];
   unsigned char  BoxQTH[16];
   unsigned char  BoxHRoute[64];
#endif DISABLE_BBS

   unsigned long  SysopANSIPen;
   unsigned long  SysopANSIStyle;
   unsigned long  UserANSIPen;
   unsigned long  UserANSIStyle;
   unsigned long  LinkANSIPen;
   unsigned long  LinkANSIStyle;
   unsigned long  SpecialANSIPen;
   unsigned long  SpecialANSIStyle;
   unsigned long  EditBuffersize;
   unsigned long  QSOBuffersize;
   unsigned long  MonitorBuffersize;
   unsigned long  EditWeight;
   unsigned long  MonitorWeight;
   unsigned long  MonEditWeight;
   unsigned long  MonMonitorWeight;

   unsigned long  BeaconMinutes;
   unsigned long  BeaconOnlyMail;
   unsigned long  BeaconNoMessage;
   unsigned char  BeaconLine[160];
   unsigned char  BeaconMailLine[80];

   struct AudioEffect AudioEffects[16];
  };


 extern struct PPPreferences Preferences;
 extern struct PPPreferences NewPref;

int PREF_LoadPreferences(void);
int PREF_SavePreferences(void);



#endif
