/*ProfiPacket - packet radio terminal program
  Copyright (C) 1999  Alexander Feigl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Author:

  Alexander Feigl
  Burachstrae 51

  D-88250 Weingarten

  Mail : Alexander.Feigl@gmx.de
*/

#ifndef CRC_H
#define CRC_H


/* Vier verschiedene CRC-Verfahren:

   Das erste ist die CRC16, (Register mit 0 initialisieren),
   das zweite ist die FCS aus AX.25 (Register mit 0xFFFF initialisieren),
   das dritte ist das CRC-Verfahren aus THP/SP/GP/DieBox (mit 0 initialisieren),
   das vierte die CRC im F6FBB - S&F (ebenfalls mit 0 initialisieren).

  */

extern void crc_16(unsigned char Data, unsigned short *crc);
extern void crcfcs(unsigned char Data, unsigned short *crc);
extern void crcthp(unsigned char Data, unsigned short *crc);
extern void crcfbb(unsigned char Data, unsigned short *crc);
extern void checksum8(unsigned char Data, unsigned short *crc);
extern void checksum16(unsigned char Data, unsigned short *crc);

extern void crc_16_buf(unsigned char *adr, long size, unsigned short *crc);
extern void crcfcs_buf(unsigned char *adr, long size, unsigned short *crc);
extern void crcthp_buf(unsigned char *adr, long size, unsigned short *crc);
extern void crcfbb_buf(unsigned char *adr, long size, unsigned short *crc);
extern void checksum8_buf(unsigned char *adr, long size, unsigned short *crc);
extern void checksum16_buf(unsigned char *adr, long size, unsigned short *crc);

#endif
